
-- NoobProof 1.5

-- Basic ipfw network firewall setup tool for Mac OS X
-- NoobProof filters selected incoming tcp/ip connections using a simple GUI
-- NoobProof is released under the terms of the GPL license
-- NoobProof is free and open-source. You can donate using paypal to hany@hanynet.com. Thank you.
-- Created by Hany El Imam on 22/11/07. ( www.hanynet.com - hany@hanynet.com )
-- Copyright 2007-2012 hanynet.com. All rights reserved.






-- global properties
property binaryPath : missing value
property dialogReturn : missing value
property appAct : missing value
property lastSelectedRow : missing value
property wizSuperNoob : missing value

-- check if this is the first noobproof start
on checkFirst()
	--check osx version
	set osxversion to do shell script "sw_vers |grep 10 |cut -f2 |cut -d \".\" -f1-2"
	if osxversion is equal to "10.4" then
		displayDialogOK("Sorry, this version of NoobProof needs Mac OS X 10.5 or later.")
		quit
	end if
	if osxversion is equal to "10.3" then
		displayDialogOK("Sorry, this version of NoobProof needs Mac OS X 10.5 or later.")
		quit
	end if
	if osxversion is equal to "10.2" then
		displayDialogOK("Sorry, this version of NoobProof needs Mac OS X 10.5 or later.")
		quit
	end if
	set firstCheck to do shell script "if [ -f \"" & binaryPath & "first\" ]; then echo \"true\" ; fi" with administrator privileges
	if firstCheck is equal to "true" then
		--
	else
		-- this is the first noobproof launch, so we start the wizard.
		flushRules()
		set the visible of box "mask" of window "noobproof" to true as boolean
		noobWizard()
		--displayDialogOK("This is the first time you launched NoobProof")
	end if
	-- creates first file. 
	do shell script "touch \"" & binaryPath & "first\"" with administrator privileges
	-- get build version
	set buildvers to do shell script "cat \"" & binaryPath & "../Info.plist\" |head -24 |tail -1 |cut -d \">\" -f2 |cut -d \"<\" -f1" with administrator privileges
	set vers to do shell script "cat \"" & binaryPath & "../Info.plist\" |head -20 |tail -1 |cut -d \">\" -f2 |cut -d \"<\" -f1" with administrator privileges
	--set the contents of text field "vers" of window "noobproof" to "V" & vers & " (build " & buildvers & ")"
	set the title of window "noobproof" to "NoobProof " & "" & vers & " (build " & buildvers & ")"
	--set the title of window "noobproof" to "NoobProof"
end checkFirst



-- AFN HANDLER
on awake from nib theObject
	-- *****************  TABLES ******************
	try
		-- build rules table datasource
		if name of theObject is "noobproof" then
			-- set path
			set myPath to path to me as string
			set macPath to (myPath & "Contents:Resources:")
			set binaryPath to POSIX path of macPath
			--
			
			--
			set theDataSource to make new data source at end of data sources with properties {name:"noobproof"}
			make new data column at end of data columns of theDataSource with properties {name:"service", sort order:ascending, sort type:alphabetical, sort case sensitivity:case sensitive}
			make new data column at end of data columns of theDataSource with properties {name:"ports", sort order:ascending, sort type:numerical, sort case sensitivity:case sensitive}
			make new data column at end of data columns of theDataSource with properties {name:"state", sort order:ascending, sort type:alphabetical, sort case sensitivity:case sensitive}
			set sorted of theDataSource to true
			set sort column of theDataSource to data column "service" of theDataSource
			set data source of theObject to theDataSource
			updateNoob()
			-- build hosts table
		else if name of theObject is "hostlist" then
			set theDataSource to make new data source at end of data sources with properties {name:"hostlist"}
			make new data column at end of data columns of theDataSource with properties {name:"host", sort order:ascending, sort type:numerical, sort case sensitivity:case sensitive}
			set sorted of theDataSource to true
			set sort column of theDataSource to data column "host" of theDataSource
			set data source of theObject to theDataSource
			-- build filters table
		else if name of theObject is "filters" then
			set theDataSource to make new data source at end of data sources with properties {name:"filters"}
			make new data column at end of data columns of theDataSource with properties {name:"host", sort order:ascending, sort type:numerical, sort case sensitivity:case sensitive}
			set sorted of theDataSource to true
			set sort column of theDataSource to data column "host" of theDataSource
			set data source of theObject to theDataSource
		else if name of theObject is "infilters" then
			set theDataSource to make new data source at end of data sources with properties {name:"infilters"}
			make new data column at end of data columns of theDataSource with properties {name:"host", sort order:ascending, sort type:numerical, sort case sensitivity:case sensitive}
			set sorted of theDataSource to true
			set sort column of theDataSource to data column "host" of theDataSource
			set data source of theObject to theDataSource
			-- DYNAMIC RULES TABLE
		else if name of theObject is "dynamic" then
			--displayDialogOK("A.F.N. - dynamic")
			set theDataSource to make new data source at end of data sources with properties {name:"tasks"}
			-- Create the data columns
			make new data column at end of data columns of theDataSource with properties {name:"prog", sort order:ascending, sort type:numerical, sort case sensitivity:case sensitive}
			make new data column at end of data columns of theDataSource with properties {name:"rule", sort order:ascending, sort type:numerical, sort case sensitivity:case sensitive}
			make new data column at end of data columns of theDataSource with properties {name:"time", sort order:ascending, sort type:numerical, sort case sensitivity:case sensitive}
			make new data column at end of data columns of theDataSource with properties {name:"proto", sort order:ascending, sort type:alphabetical, sort case sensitivity:case sensitive}
			make new data column at end of data columns of theDataSource with properties {name:"from", sort order:ascending, sort type:numerical, sort case sensitivity:case sensitive}
			make new data column at end of data columns of theDataSource with properties {name:"sport", sort order:ascending, sort type:numerical, sort case sensitivity:case sensitive}
			make new data column at end of data columns of theDataSource with properties {name:"to", sort order:ascending, sort type:numerical, sort case sensitivity:case sensitive}
			make new data column at end of data columns of theDataSource with properties {name:"dport", sort order:ascending, sort type:numerical, sort case sensitivity:case sensitive}
			make new data column at end of data columns of theDataSource with properties {name:"pkts", sort order:ascending, sort type:numerical, sort case sensitivity:case sensitive}
			make new data column at end of data columns of theDataSource with properties {name:"size", sort order:ascending, sort type:numerical, sort case sensitivity:case sensitive}
			-- Set the data source as sorted
			set sorted of theDataSource to true
			-- Set the "item" data column as the sort column
			set sort column of theDataSource to data column "prog" of theDataSource
			-- Finally, assign the data source of the table view to our data source
			set data source of theObject to theDataSource
			
		end if
	on error nooberr
		displayDialogOK("AFN error: " & nooberr)
	end try
end awake from nib

-- ********************************** UPDATE MATRIX **************************************
-- update action matrix to reflect rules table selection
on updateMatrix()
	set tableView to table view "noobproof" of scroll view "noobproof" of window "noobproof"
	set rulestate to the contents of data cell "state" of selected data row of tableView as string
	set srvname to the contents of data cell "service" of selected data row of tableView as string
	set the contents of text field "srvname" of window "noobproof" to do shell script "echo \"" & srvname & "\" | cut -d\"#\" -f1"
	set selectedRow to selected row of tableView
	--displayDialogOK("row: " & selectedRow & " - state: " & rulestate)
	if rulestate is equal to "deny" then
		set the current row of matrix "action" of window "noobproof" to "2"
	else if rulestate is equal to "allow" then
		set the current row of matrix "action" of window "noobproof" to "1"
	else if rulestate is equal to "deny only.." then
		set the current row of matrix "action" of window "noobproof" to "4"
	else if rulestate is equal to "allow only.." then
		set the current row of matrix "action" of window "noobproof" to "3"
	end if
	checkonly()
end updateMatrix



-- ********************************** STATE UPDATE **************************************
-- update state of selected service when action matrix selection changes (writes to conf)
on stateUpdate()
	-- debug
	--displayDialogOK("stateUpdate begins")
	set theConf to (binaryPath & "/np.conf")
	set theTempConf to (binaryPath & "/np.conf.tmp")
	set noobTableView to table view "noobproof" of scroll view "noobproof" of window "noobproof"
	set hostTableView to table view "hostlist" of scroll view "hostlist" of window "noobproof"
	set selectedRow to selected row of noobTableView
	set srvname to the contents of data cell "service" of selected data row of noobTableView
	set oldstate to the contents of data cell "state" of selected data row of noobTableView
	if the current row of matrix "action" of window "noobproof" is equal to 1 then
		set newstate to "allow"
		--displayDialogOK("state1")
	else if the current row of matrix "action" of window "noobproof" is equal to 2 then
		set newstate to "deny"
		--displayDialogOK("state2")
	else if the current row of matrix "action" of window "noobproof" is equal to 3 then
		set newstate to "allow only.."
		--displayDialogOK("state3")
	else if the current row of matrix "action" of window "noobproof" is equal to 4 then
		set newstate to "deny only.."
		--displayDialogOK("state4")
	end if
	set selectedRowContent to do shell script "cat \"" & theConf & "\" | grep \"" & srvname & "\"" with administrator privileges
	set newRowContent to do shell script "echo \"" & selectedRowContent & "\"| sed 's/" & oldstate & "/" & newstate & "/'"
	----------------------------------------------------------
	-- remove hosts if new rule is 'allow' or 'deny'
	if the current row of matrix "action" of window "noobproof" is equal to 1 or the current row of matrix "action" of window "noobproof" is equal to 2 then
		--displayDialogOK("cleaning row from hosts. old row was: " & newRowContent)
		set newRow to do shell script "echo \"" & newRowContent & "\" |cut -d\"@\" -f1"
		set newRow to (newRow & "@")
		set newRowContent to newRow
		--displayDialogOK("cleaned row from hosts. new row is: " & newRowContent)
		-- clean the damn hosts table
		set the content of table view "hostlist" of scroll view "hostlist" of window "noobproof" to {}
	end if
	--------------------------------------------------------
	-- debug
	--displayDialogOK("old rule: " & selectedRowContent)
	--displayDialogOK("must change in : " & newRowContent)
	-- update np.conf
	do shell script "cat \"" & theConf & "\" |grep -v \"" & srvname & "\" > \"" & theTempConf & "\"" with administrator privileges
	do shell script "echo \"" & newRowContent & "\" >> \"" & theTempConf & "\"" with administrator privileges
	do shell script "/bin/cp \"" & theTempConf & "\" \"" & theConf & "\"" with administrator privileges
	-- debug
	--set debugstate to do shell script "cat \"" & theConf & "\" | grep \"" & srvname & "\"" with administrator privileges
	--displayDialogOK("reading conf file: " & debugstate)
	
end stateUpdate



-- ********************************** UPDATE NOOB **************************************
-- update rules table (reads conf file)
on updateNoob()
	-- debug
	--displayDialogOK("updateNoob begins")
	set selectedRuleRow to selected row of table view "noobproof" of scroll view "noobproof" of window "noobproof"
	try
		startSpin()
		set theWindow to window "noobproof"
		set the enabled of matrix "action" of theWindow to false as boolean
		set theTableView to table view "noobproof" of scroll view "noobproof" of theWindow
		set the content of theTableView to {}
		set theDataSource to data source of theTableView
		set theConf to (binaryPath & "/np.conf")
		set confLines to do shell script "cat \"" & theConf & "\" | wc -l |bc " with administrator privileges
		set theConfig to do shell script "cat \"" & theConf & "\"" with administrator privileges
		set icount to 1
		try
			set AppleScript's text item delimiters to "#"
			repeat with icount from 1 to confLines
				--displayDialogOK(icount)
				set servicename to the first text item of paragraph (icount) of theConfig
				set serviceports to the second text item of paragraph (icount) of theConfig
				set servicestate to the third text item of paragraph (icount) of theConfig
				--set servicestate to do shell script "cat \"" & theConf & "\" | head -" & icount & " |tail -1 |cut -d \"#\" -f3" with administrator privileges
				set theTask to make new data row at end of data rows of theDataSource
				set contents of data cell "service" of theTask to servicename
				set contents of data cell "ports" of theTask to serviceports
				set contents of data cell "state" of theTask to servicestate
			end repeat
			set sort column of theDataSource to data column "service" of theDataSource
		on error nooberr
			displayDialogOK("updatenoob loop error: " & nooberr)
		end try
		set the enabled of matrix "action" of theWindow to true as boolean
		stopSpin()
	on error nooberr
		displayDialogOK("updatenoob error: " & nooberr)
	end try
	set selected row of table view "noobproof" of scroll view "noobproof" of window "noobproof" to selectedRuleRow
end updateNoob




-- ********************************** CHECK ONLY **************************************
-- check for 'only' option and set the GUI
on checkonly()
	-- debug
	--displayDialogOK("checkonly begins")
	try
		if the current row of matrix "action" of window "noobproof" is equal to 3 or the current row of matrix "action" of window "noobproof" is equal to 4 then
			
			
			-- show host list table and buttons
			set the visible of scroll view "hostlist" of window "noobproof" to true as boolean
			set the visible of button "openadd" of window "noobproof" to true as boolean
			set the visible of button "delete" of window "noobproof" to true as boolean
		else
			-- hide them
			set the visible of scroll view "hostlist" of window "noobproof" to false as boolean
			set the visible of button "openadd" of window "noobproof" to false as boolean
			set the visible of button "delete" of window "noobproof" to false as boolean
		end if
	on error nooberr
		displayDialogOK("checkonly error: " & nooberr)
	end try
end checkonly


-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

-- ********************************** UPDATE HOSTS **************************************
-- update hosts list table if selected rule has a 'only' option set in action matrix
on updateHosts()
	-- debug
	--displayDialogOK("updatehosts begins")
	set theConf to (binaryPath & "/np.conf")
	set noobTableView to table view "noobproof" of scroll view "noobproof" of window "noobproof"
	set hostTableView to table view "hostlist" of scroll view "hostlist" of window "noobproof"
	set rulestate to the contents of data cell "state" of selected data row of noobTableView as string
	set srvname to the contents of data cell "service" of selected data row of noobTableView as string
	--displayDialogOK("UPDATEHOSTS1:  row of noobtableview: " & selected row of noobTableView & " - srv name: " & srvname)
	set selectedRow to selected row of noobTableView
	if rulestate is equal to "deny only.." or rulestate is equal to "allow only.." then
		--conta numero host nella regola
		set hostslist to do shell script "cat \"" & theConf & "\" | grep \"" & srvname & "\" |grep \"@\" |cut -d \"@\" -f2- " with administrator privileges
		--------------
		set hostnum to do shell script "echo \"" & hostslist & "\" | grep -o \"X\" | wc -l |bc "
		--set hostnum to (hostnum + 1 - 1)
		-- debug
		--displayDialogOK("UPDATEHOSTS: rule state: " & rulestate & " hostnum: " & hostnum & " sel.row: " & selectedRow & " srv: " & srvname)
		--aggiungi una riga alla tabella hostlist per ogni host di questo servizio in np.conf
		set hcount to 1
		set the content of hostTableView to {}
		set theDataSource to data source of hostTableView
		repeat with hcount from 1 to hostnum
			--displayDialogOK("conto " & hcount & " su " & hostnum)
			
			set hostString to do shell script "echo \"" & hostslist & "\" | cut -d \"X\" -f" & hcount
			-- debug
			--displayDialogOK("UPDATEHOSTSreading conf: servname: " & srvname & " - hosts in list: " & hostnum & " - this host: " & hostString)
			set theTask to make new data row at end of data rows of theDataSource
			set contents of data cell "hostlist" of theTask to hostString
			set hcount to hcount + 1
		end repeat
	end if
end updateHosts


-- clicked handler (single mouse-click on buttons or tables)
on clicked theObject
	------------------------------------------------------------
	-- ******* CHANGE SELECTION IN RULES TABLE
	--------------------------------------------------------------
	if the name of theObject is equal to "noobproof" then
		-- clean hosts list table
		set the content of table view "hostlist" of scroll view "hostlist" of window "noobproof" to {}
		
		updateMatrix() -- read conf file and update the selected option in action matrix reflecting selected service state
		updateHosts() -- updates hosts list table adding hosts reading from conf file
	else if the name of theObject is equal to "paypaldonate" then
		do shell script "open http://www.hanynet.com/donate.html"
		--------------------------------------------------------------------------------		-- ********** CHANGE SELECTION IN ACTION MATRIX
		--------------------------------------------------------------------------------
	else if the name of theObject is equal to "action" then
		set selectedRuleRow to selected row of table view "noobproof" of scroll view "noobproof" of window "noobproof"
		
		stateUpdate() -- writes new state to conf
		updateNoob() -- updates rules table
		checkonly() -- displays hosts list if action matrix is 'allow only' or 'deny only'
		addIpfwRules() -- updates ipfw rules issuing shell commands (if noobproof is active)
		
		
		set selected row of table view "noobproof" of scroll view "noobproof" of window "noobproof" to selectedRuleRow
		
		
		-------------------------------------------------------------------------------------------------------------------
		-- click 'add host or subnet' button
	else if the name of theObject is equal to "add" then
		addHost()
		-- click 'delete host or subnet' button
	else if the name of theObject is equal to "delete" then
		deleteHost()
		-- click 'activate noobproof'
	else if the name of theObject is equal to "activate" then
		try
			if the contents of button "activate" of window "noobproof" is equal to false as boolean then
				--displayDialogOK("spento")
				
				----
				if the title of button "activate" of window "noobproof" is equal to "Reset firewall" then
					set the contents of text field "led" of window "noobproof" to "Mac OS X firewall is active."
					set the enabled of button "stealth" of window "noobproof" to true as boolean
					set the enabled of button "inj" of window "noobproof" to true as boolean
					set the enabled of button "filters" of window "noobproof" to true as boolean
					set the enabled of button "openbw" of window "noobproof" to true as boolean
					set the enabled of button "flush" of window "noobproof" to true as boolean
					set the enabled of button "showlogs" of window "noobproof" to true as boolean
					set the enabled of button "showrules" of window "noobproof" to true as boolean
					set the enabled of button "import" of window "noobproof" to true as boolean
					set the enabled of button "export" of window "noobproof" to true as boolean
					set the enabled of button "tools" of window "noobproof" to true as boolean
					set the enabled of button "options" of window "noobproof" to true as boolean
					set the enabled of button "addrule" of window "noobproof" to true as boolean
					set the enabled of button "deleterule" of window "noobproof" to true as boolean
					set the enabled of button "restoreset" of window "noobproof" to true as boolean
					set the enabled of button "cleantable" of window "noobproof" to true as boolean
					set the enabled of button "openadd" of window "noobproof" to true as boolean
					set the enabled of button "delete" of window "noobproof" to true as boolean
					set the enabled of matrix "action" of window "noobproof" to true as boolean
				end if
				---
				set the contents of text field "led" of window "noobproof" to "Mac OS X firewall is not active. " as string
				set the enabled of button "flush" of window "noobproof" to true as boolean
				set the enabled of button "openbw" of window "noobproof" to true as boolean
				set the enabled of button "saveconf" of window "tools" to false as boolean
				set the enabled of button "import" of window "noobproof" to true as boolean
				set the enabled of button "export" of window "noobproof" to true as boolean
				set the enabled of button "stealth" of window "noobproof" to true as boolean
			else
				--displayDialogOK("acceso")
				set the contents of text field "led" of window "noobproof" to "Mac OS X firewall is active." as string
				set the enabled of button "flush" of window "noobproof" to false as boolean
				set the enabled of button "openbw" of window "noobproof" to false as boolean
				set the enabled of button "saveconf" of window "tools" to true as boolean
				set the enabled of button "import" of window "noobproof" to false as boolean
				set the enabled of button "export" of window "noobproof" to false as boolean
				set the enabled of button "stealth" of window "noobproof" to false as boolean
			end if
			noobStart()
			checkLock()
			if the contents of button "activate" of window "noobproof" is equal to false as boolean then
				flushRules()
			end if
			set the contents of text view "showrules" of scroll view "showrules" of window "showrules" to ""
			set the contents of text view "showrules" of scroll view "showrules" of window "showrules" to do shell script "/sbin/ipfw list" with administrator privileges
		on error errorText
			displayDialogOK("error activating noobproof: " & errorText)
		end try
	else if the name of theObject is equal to "addrule" then
		set the contents of text field "service" of window "service" to ""
		set the contents of text field "port" of window "service" to ""
		display window "service" attached to window "noobproof"
		-- close 'add new service' panel
	else if the name of theObject is equal to "close" then
		close panel (window of theObject)
		saveOptionsPrefs()
	else if the name of theObject is equal to "closewin" then
		set the visible of (window of theObject) to false as boolean
		-- add new custom service
	else if the name of theObject is equal to "addservice" then
		addCustom()
		-- delete selected custom service
	else if the name of theObject is equal to "deleterule" then
		deleteCustom()
		-- options
	else if the name of theObject is equal to "options" then
		if the contents of button "activate" of window "noobproof" is equal to true as boolean then
			displayDialogOK("You must stop NoobProof to change options.")
		else
			loadOptionsPrefs()
			display window "options" attached to window "noobproof"
		end if
		-- tools
	else if the name of theObject is equal to "tools" then
		display window "tools" attached to window "noobproof"
		-- help
	else if the name of theObject is equal to "noobhelp" then
		display window "help" attached to window "noobproof"
	else if the name of theObject is equal to "flush" then
		flushRules()
		displayDialogOK("Rules and pipes succesfully flushed. Firewall has been reset to factory-default.")
		set the content of button "activate" of window "noobproof" to 0
	else if the name of theObject is equal to "showrules" then
		set the contents of text view "showrules" of scroll view "showrules" of window "showrules" to ""
		set the contents of text view "showrules" of scroll view "showrules" of window "showrules" to do shell script "/sbin/ipfw list" with administrator privileges
		set the visible of window "showrules" to true as boolean
		show window "showrules"
		--display window "showrules" attached to window "noobproof"
	else if the name of theObject is equal to "updaterules" then
		set the contents of text view "showrules" of scroll view "showrules" of window "showrules" to ""
		set the contents of text view "showrules" of scroll view "showrules" of window "showrules" to do shell script "/sbin/ipfw list" with administrator privileges
	else if the name of theObject is equal to "installstartup" then
		installStartup()
		displayDialogOK("Startup Script installed.")
	else if the name of theObject is equal to "removestartup" then
		removeStartup()
	else if the name of theObject is equal to "saveconf" then
		backupConf()
		displayDialogOK("Firewall configuration saved. ")
	else if the name of theObject is equal to "restoreset" then
		restoreNoob()
		displayDialogOK("Default NoobProof service list, service status, black lists, bandwidth and options restored.")
	else if the name of theObject is equal to "cleantable" then
		restoreSmallNoob()
	else if the name of theObject is equal to "uninstall" then
		uninstallNoob()
		displayDialogOK("Noobproof scripts uninstalled.")
	else if the name of theObject is equal to "showlogs" then
		close panel (window "tools")
		showLogs()
	else if the name of theObject is equal to "updatelogs" then
		showLogs()
	else if the name of theObject is equal to "openadd" then
		display window "newhost" attached to window "noobproof"
	else if the name of theObject is equal to "export" then
		exportConf()
	else if the name of theObject is equal to "import" then
		importConf()
	else if the name of theObject is equal to "portnumbers" then
		do shell script "open /etc/services"
	else if the name of theObject is equal to "morelogs" then
		showTermLogs()
	else if the name of theObject is equal to "livelogs" then
		showLiveLogs()
	else if the name of theObject is equal to "openbw" then
		loadOptionsPrefs()
		display window "bw" attached to window "noobproof"
		---
		-- SUPERNOOB -- STATEFUL FIREWALL MODE 
	else if the name of theObject is equal to "stealth" then
		stealthMode()
	else if the name of theObject is equal to "showdyn" then
		--display window "dynamic" attached to window "noobproof"
		
		set the visible of window "dynamic" to true as boolean
		show window "dynamic"
		updateDynamic()
	else if the name of theObject is equal to "updatedynamic" then
		updateDynamic()
		-- bandwidth gui
	else if the name of theObject is equal to "bw1" then
		if the content of button "bw1" of window "bw" is equal to true as boolean then
			set the enabled of button "bw2" of window "bw" to false as boolean
			set the enabled of button "bwshare" of window "bw" to false as boolean
			set the enabled of button "bwlan" of window "bw" to false as boolean
			set the enabled of button "bwdelay" of window "bw" to false as boolean
		else
			set the enabled of button "bw2" of window "bw" to true as boolean
			set the enabled of button "bwshare" of window "bw" to true as boolean
			set the enabled of button "bwlan" of window "bw" to true as boolean
			set the enabled of button "bwdelay" of window "bw" to true as boolean
		end if
	else if the name of theObject is equal to "bw2" then
		if the content of button "bw2" of window "bw" is equal to true as boolean then
			set the enabled of button "bw1" of window "bw" to false as boolean
			set the enabled of button "bwftp" of window "bw" to false as boolean
			set the enabled of button "bwweb" of window "bw" to false as boolean
			set the enabled of button "bwp2p" of window "bw" to false as boolean
			set the enabled of button "bwports" of window "bw" to false as boolean
			set the enabled of text field "bwports" of window "bw" to false as boolean
		else
			set the enabled of button "bw1" of window "bw" to true as boolean
			set the enabled of button "bwftp" of window "bw" to true as boolean
			set the enabled of button "bwweb" of window "bw" to true as boolean
			set the enabled of button "bwp2p" of window "bw" to true as boolean
			set the enabled of button "bwports" of window "bw" to true as boolean
			set the enabled of text field "bwports" of window "bw" to true as boolean
		end if
		-- injector
	else if the name of theObject is equal to "inj" then
		if the content of button "activate" of window "noobproof" is equal to true as boolean or the content of button "stealth" of window "noobproof" is equal to true as boolean then
			display window "inj" attached to window "noobproof"
		else
			displayDialogOK("You must 'Start Firewall' before using BOFH Injector Creator.")
		end if
	else if the name of theObject is equal to "createinj" then
		createInjector()
		
		-- WIZARD
	else if the name of theObject is equal to "closewizard" then
		set the visible of box "mask" of window "noobproof" to false as boolean
		getWizardConf()
	else if the name of theObject is equal to "next1" then
		set the visible of box "mask" of window "noobproof" to true as boolean
		close panel (window "wizard1")
		display window "wizard2" attached to window "noobproof"
	else if the name of theObject is equal to "next2" then
		-- check if supernoobmode is selected and set a global variable
		set wizMode to current row of matrix "wizard2" of window "wizard2" -- normal mode or noobproof mode
		if wizMode is equal to 2 then
			set wizSuperNoob to true as boolean
			close panel (window "wizard2")
			display window "wizard5" attached to window "noobproof"
		else
			set wizSuperNoob to false as boolean
			close panel (window "wizard2")
			display window "wizard3" attached to window "noobproof"
		end if
		
	else if the name of theObject is equal to "next3" then
		close panel (window "wizard3")
		display window "wizard4" attached to window "noobproof"
	else if the name of theObject is equal to "next4" then
		close panel (window "wizard4")
		display window "wizardbw" attached to window "noobproof"
	else if the name of theObject is equal to "next5" then
		close panel (window "wizard5")
		display window "wizard6" attached to window "noobproof"
	else if the name of theObject is equal to "nextbw" then
		close panel (window "wizardbw")
		display window "wizard5" attached to window "noobproof"
	else if the name of theObject is equal to "restartwizard" then
		close panel (window of theObject)
		display window "wizard1" attached to window "noobproof"
		set the visible of box "mask" of window "noobproof" to true as boolean
		--
	else if the name of theObject is equal to "abortwiz" then
		set the visible of box "mask" of window "noobproof" to false as boolean
		close panel (window of theObject)
		displayDialogOK("Wizard aborted. You can restart the Wizard from the \"Tools\" menu")
		set wizSuperNoob to false as boolean
		updateMatrix()
	else if the name of theObject is equal to "back6" then
		close panel (window "wizard6")
		display window "wizard5" attached to window "noobproof"
	else if the name of theObject is equal to "back5" then
		close panel (window "wizard5")
		display window "wizardbw" attached to window "noobproof"
	else if the name of theObject is equal to "backbw" then
		close panel (window "wizardbw")
		display window "wizard4" attached to window "noobproof"
	else if the name of theObject is equal to "back4" then
		close panel (window "wizard4")
		display window "wizard3" attached to window "noobproof"
	else if the name of theObject is equal to "back3" then
		close panel (window "wizard3")
		display window "wizard2" attached to window "noobproof"
		-------
	else if the name of theObject is equal to "closebw" then
		close panel (window of theObject)
		addIpfwRules()
		saveOptionsPrefs()
		set the contents of text view "showrules" of scroll view "showrules" of window "showrules" to ""
		set the contents of text view "showrules" of scroll view "showrules" of window "showrules" to do shell script "/sbin/ipfw list" with administrator privileges
		-- wizard bandwidth settings
	else if the name of theObject is equal to "bwmatrix" then
		checkwizBWmatrix()
	else if the name of theObject is equal to "bwuno" then
		set the content of text field "bw" of box "bw" of window "wizardbw" to "200"
	else if the name of theObject is equal to "bwdue" then
		set the content of text field "bw" of box "bw" of window "wizardbw" to "80"
	else if the name of theObject is equal to "bw3" then
		set the content of text field "bw" of box "bw" of window "wizardbw" to "40"
	else if the name of theObject is equal to "bw4" then
		set the content of text field "bw" of box "bw" of window "wizardbw" to "16"
	else if the name of theObject is equal to "bw5" then
		set the content of text field "bw" of box "bw" of window "wizardbw" to "7"
		-- 
	else if the name of theObject is equal to "bwdelay" then
		set the contents of button "latency" of box "bw" of window "wizardbw" to (the contents of button "bwdelay" of window "bw")
	else if the name of theObject is equal to "latency" then
		set the contents of button "bwdelay" of window "bw" to (the contents of button "latency" of box "bw" of window "wizardbw")
		
	else if the name of theObject is equal to "getnetconf" then
		getNetworkConf()
		--------------
		--- FILTERS
	else if the name of theObject is equal to "filters" then
		display window "filters" attached to window "noobproof"
		updateFilters()
		updateinFilters()
	else if the name of theObject is equal to "addfilters" then
		display window "addfilters" attached to window "filters"
	else if the name of theObject is equal to "addnewfilter" then
		addFilters()
		close panel (window "addfilters")
		updateFilters()
		addIpfwRules()
	else if the name of theObject is equal to "deletefilters" then
		deleteFilters()
		updateFilters()
		addIpfwRules()
	else if the name of theObject is equal to "cleanfilters" then
		cleanFilters()
		updateFilters()
		addIpfwRules()
	else if the name of theObject is equal to "logfilters" then
		addIpfwRules()
	else if the name of theObject is equal to "addinfilters" then
		display window "addinfilters" attached to window "filters"
	else if the name of theObject is equal to "addnewinfilter" then
		addinFilters()
		close panel (window "addinfilters")
		updateinFilters()
		addIpfwRules()
	else if the name of theObject is equal to "deleteinfilters" then
		deleteinFilters()
		updateinFilters()
		addIpfwRules()
	else if the name of theObject is equal to "cleaninfilters" then
		cleaninFilters()
		updateinFilters()
		addIpfwRules()
	else if the name of theObject is equal to "loginfilters" then
		addIpfwRules()
		-------------------
	end if
end clicked


on checkwizBWmatrix()
	if the current row of matrix "bwmatrix" of window "wizardbw" is equal to 2 then
		set the visible of box "bw" of window "wizardbw" to false as boolean
	else
		set the visible of box "bw" of window "wizardbw" to true as boolean
	end if
end checkwizBWmatrix


-- ********************************** ADD IPFW RULES  (ISSUE SHELL COMMANDS) **************************************

on addIpfwRules()
	--
	if the contents of button "activate" of window "noobproof" is equal to true as boolean then
		set the title of button "activate" of window "noobproof" to "Stop firewall"
	else
		set the title of button "activate" of window "noobproof" to "Start firewall"
	end if
	--
	try
		if the contents of button "activate" of window "noobproof" is equal to true as boolean then
			-- check log option
			if the content of button "logopt" of window "options" is equal to true as boolean then
				set logOpt to " log "
			else
				set logOpt to ""
			end if
			if the content of button "logoptudp" of window "options" is equal to true as boolean then
				set logOptUDP to " log "
			else
				set logOptUDP to ""
			end if
			startSpin()
			flushRules()
			
			try
				-- allow loopback
				do shell script "/sbin/ipfw add 100 allow ip from any to any via lo*" with administrator privileges
				-------------------------------------------------------------
				-- ADD OUT FILTERS
				set filterString to do shell script "cat \"" & binaryPath & "filters\" |sed s/#/,/g |sed 's/\\(.*\\)./\\1/'" with administrator privileges
				if filterString is not equal to "" then
					if the contents of button "logfilters" of window "filters" is equal to false as boolean then
						set filterslogopt to " "
					else
						set filterslogopt to " log "
					end if
					do shell script "/sbin/ipfw add 3000 deny " & filterslogopt & " ip from any to " & filterString & " out" with administrator privileges
				end if
				-- ADD IN FILTERS
				set filterinString to do shell script "cat \"" & binaryPath & "infilters\" |sed s/#/,/g |sed 's/\\(.*\\)./\\1/'" with administrator privileges
				if filterinString is not equal to "" then
					if the contents of button "loginfilters" of window "filters" is equal to false as boolean then
						set infilterslogopt to " "
					else
						set infilterslogopt to " log "
					end if
					do shell script "/sbin/ipfw add 3500 deny " & infilterslogopt & " ip from " & filterinString & " to any in" with administrator privileges
				end if
				-------------------------------------------------------------
				-- add optional rules (icmp, nmap scan, junk packets ...)
				if the content of button "icmp" of window "options" is equal to 1 as boolean then
					if the content of button "logopticmp" of window "options" is equal to true as boolean then
						do shell script "/sbin/ipfw add 1000 deny log icmp from any to me in icmptypes 8" with administrator privileges
					else
						do shell script "/sbin/ipfw add 1000 deny icmp from any to me in icmptypes 8" with administrator privileges
					end if
					
				end if
				if the content of button "nmap" of window "options" is equal to 1 as boolean then
					do shell script "/sbin/ipfw add 1100 deny ip from any to any ipoptions rr" with administrator privileges
					do shell script "/sbin/ipfw add 1101 deny ip from any to any ipoptions ts" with administrator privileges
					do shell script "/sbin/ipfw add 1102 deny ip from any to any ipoptions lsrr" with administrator privileges
					do shell script "/sbin/ipfw add 1103 deny ip from any to any ipoptions ssrr" with administrator privileges
				end if
				if the content of button "dangerous" of window "options" is equal to 1 as boolean then
					do shell script "/sbin/ipfw add 1200 deny tcp from any to any tcpflags syn,fin" with administrator privileges
					do shell script "/sbin/ipfw add 1201 deny tcp from any to any tcpflags syn,rst" with administrator privileges
					do shell script "/sbin/ipfw add 1202 deny tcp from any 0 to any" with administrator privileges
					do shell script "/sbin/ipfw add 1203 deny tcp from any to any dst-port 0" with administrator privileges
					do shell script "/sbin/ipfw add 1204 deny udp from any 0 to any" with administrator privileges
					do shell script "/sbin/ipfw add 1205 deny udp from any to any dst-port 0" with administrator privileges
					do shell script "/sbin/ipfw add 1206 deny ip from 224.0.0.0/4 to any in" with administrator privileges
					do shell script "/sbin/ipfw add 1207 deny ip from 0.0.0.0/8 to any" with administrator privileges
					
				end if
				-- read np.conf and add service based rules 
				--count rules
				set theConf to (binaryPath & "/np.conf")
				set rulesNum to do shell script "cat \"" & theConf & "\" |wc -l |bc" with administrator privileges
				repeat with rcount from 1 to rulesNum
					set ruleRow to do shell script "cat \"" & theConf & "\" |head -" & rcount & " |tail -1" with administrator privileges
					set ruleFrom to "any"
					set rulePorts to do shell script "echo \"" & ruleRow & "\" |cut -d \"#\" -f2"
					set UDPrulePorts to rulePorts
					if rulePorts is equal to "" then
						------------------------------------------------
						-- add rules for "All Other Services"
						------------------------------------------------
						set rulestate to do shell script "echo \"" & ruleRow & "\" |cut -d \"#\" -f3"
						-- check 'only' option...
						if rulestate is equal to "allow only.." or rulestate is equal to "deny only.." then
							-- get hosts
							set hostscount to do shell script "echo \"" & ruleRow & "\" | cut -d \"@\" -f2 |grep -o X |wc -l |bc"
							if hostscount is equal to "0" then
								set ruleFrom to "any"
							else
								set ruleFrom to do shell script "echo \"" & ruleRow & "\" | cut -d \"@\" -f2 |sed 's/X/,/g' |sed -e 's/.$//'"
							end if
							if rulestate is equal to "allow only.." then
								set rulestate to "allow"
							else if rulestate is equal to "deny only.." then
								set rulestate to "deny"
							end if
						end if
						-- set the log option
						if rulestate is equal to "allow only.." or rulestate is equal to "allow" then
							if the content of button "logoptallow" of window "options" is equal to true as boolean then
								set logOpt to "log"
							else
								set logOpt to ""
							end if
						else
							if the content of button "logopt" of window "options" is equal to true as boolean then
								set logOpt to "log"
							else
								set logOpt to ""
							end if
						end if
						if the content of button "logoptudp" of window "options" is equal to true as boolean then
							if rulestate is equal to "deny only.." or rulestate is equal to "deny" then
								set logOptUDP to " log "
							else
								set logOptUDP to ""
							end if
						else
							set logOptUDP to ""
						end if
						--TCP
						do shell script "/sbin/ipfw add 63000 " & rulestate & " " & logOpt & " tcp from " & ruleFrom & " to any in" with administrator privileges
						-- UDP
						if the current row of matrix "proto" of window "options" is equal to 1 then
							do shell script "/sbin/ipfw add 63001 " & rulestate & " " & logOptUDP & " udp from " & ruleFrom & " to any dst-port 1-1023 in" with administrator privileges
						else if the current row of matrix "proto" of window "options" is equal to 2 then
							do shell script "/sbin/ipfw add 63001 " & rulestate & " " & logOptUDP & " udp from " & ruleFrom & " to any in" with administrator privileges
						else if the current row of matrix "proto" of window "options" is equal to 3 then
							--
						end if
					else
						-----------------------------------------------------------
						-- add rules for standard and custom services
						-----------------------------------------------------------
						
						set rulestate to do shell script "echo \"" & ruleRow & "\" |cut -d \"#\" -f3"
						--displayDialogOK("rulestate: " & rulestate) -- debug!
						set rulestatesrc to rulestate
						set ruleNumber to (10000 + (100 * rcount))
						-- check 'only' option...
						if rulestate is equal to "allow only.." or rulestate is equal to "deny only.." then
							-- get hosts
							set hostscount to do shell script "echo \"" & ruleRow & "\" | cut -d \"@\" -f2 |grep -o X |wc -l |bc"
							if hostscount is equal to "0" then
								set ruleFrom to "any"
							else
								set ruleFrom to do shell script "echo \"" & ruleRow & "\" | cut -d \"@\" -f2 |sed 's/X/,/g' |sed -e 's/.$//'"
							end if
							if rulestate is equal to "allow only.." then
								set rulestate to "allow"
							else if rulestate is equal to "deny only.." then
								set rulestate to "deny"
							end if
						end if
						-- set the log option
						if rulestate is equal to "allow only.." or rulestate is equal to "allow" then
							if the content of button "logoptallow" of window "options" is equal to true as boolean then
								set logOpt to "log"
							else
								set logOpt to ""
							end if
						end if
						if rulestate is equal to "deny only.." or rulestate is equal to "deny" then
							if the content of button "logopt" of window "options" is equal to true as boolean then
								set logOpt to "log"
							else
								set logOpt to ""
							end if
						end if
						if the content of button "logoptudp" of window "options" is equal to true as boolean then
							set logOptUDP to " log "
						else
							set logOptUDP to ""
						end if
						
						
						-- issue ipfw shell commands
						-- TCP
						do shell script "/sbin/ipfw add " & ruleNumber & " " & rulestate & " " & logOpt & " tcp from " & ruleFrom & " to any dst-port " & rulePorts & " in " with administrator privileges
						-- UDP
						if the current row of matrix "proto" of window "options" is not equal to 3 then
							do shell script "/sbin/ipfw add " & (ruleNumber + 10) & " " & rulestate & " " & logOptUDP & " udp from " & ruleFrom & " to any dst-port " & UDPrulePorts & " in" with administrator privileges
						end if
						-- ALLOW/DENY POLICIES
						-- add a 'deny' rule for the 'allow only..' rules
						if rulestatesrc is equal to "allow only.." then
							--displayDialogOK("allow only rule: adding 3 rules!")
							if the content of button "logopt" of window "options" is equal to true as boolean then
								set logOpt to "log"
							else
								set logOpt to ""
							end if
							do shell script "/sbin/ipfw add " & (ruleNumber + 12) & " " & " deny " & logOpt & " " & " ip from " & " any " & " to any dst-port " & rulePorts & " in" with administrator privileges
						end if
						if rulestatesrc is equal to "deny only.." then
							--displayDialogOK("deny only rule: adding 3 rules!")
							if the content of button "logoptallow" of window "options" is equal to true as boolean then
								set logOpt to "log"
							else
								set logOpt to ""
							end if
							do shell script "/sbin/ipfw add " & (ruleNumber + 13) & " " & " allow " & logOpt & " " & " ip from " & " any " & " to any dst-port " & rulePorts & " in" with administrator privileges
						end if
					end if
				end repeat
			on error errorText
				displayDialogOK("Error: " & errorText)
			end try
			stopSpin()
		end if
	on error nooberr
		displayDialogOK("addipfw error: " & nooberr)
	end try
	-- issue dummynet bandwidth rules and pipes configuration
	Dummynet()
	set the contents of text view "showrules" of scroll view "showrules" of window "showrules" to ""
	set the contents of text view "showrules" of scroll view "showrules" of window "showrules" to do shell script "/sbin/ipfw list" with administrator privileges
	
end addIpfwRules

-- ---------------------------------------------------------------------------------------------------------


-- LAUNCH

on launched theObject
	-- BETA MESSAGE
	--displayDialogOK("Welcome to NoobProof Public Beta. Please send bug reports to hany@hanynet.com . Thank you.")
	--displayDialogOK("NoobProof 1.4 **PRIVATE** beta build 188 - PLEASE DO NOT DISCLOSE - use at your own risk")
	-- AUTH CHECK
	loadOptionsPrefs()
	try
		--
		set the title of button "activate" of window "noobproof" to "Start firewall"
		--
		do shell script "sudo -k" -- invalidates the user's timestamp
		do shell script "sudo -v" with administrator privileges
		set the visible of window "noobproof" to true as boolean
		show window "noobproof"
		checkFirst()
	on error errorText
		displayDialogOK("Authentication error! " & errorText & " NoobProof will now quit.")
		quit
	end try
	-------------
end launched
-- duh
on action theObject
	if the name of theObject is equal to "hanynet" then
		do shell script "open http://www.hanynet.com"
	end if
end action
-- popup menu action in 'add new service' window
on choose menu item theObject
	if the name of theObject is equal to "more" then
		display window "help" attached to window "noobproof"
		
	else if the name of theObject is equal to "wizard" then
		display window "wizard1" attached to window "noobproof"
		set the visible of box "mask" of window "noobproof" to true as boolean
	else if the name of theObject is equal to "showlicense" then
		showLicense()
	else if the name of theObject is equal to "menurules" then
		set the visible of window "showrules" to true as boolean
		show window "showrules"
	else if the name of theObject is equal to "nhelp" then
		set the visible of window "morehelp" to true as boolean
		show window "morehelp"
	else if the name of theObject is equal to "restore" then
		restoreNoob()
		displayDialogOK("Default NoobProof service list, service status, bandwidth and options restored.")
	else if the name of theObject is equal to "uninstall" then
		uninstallNoob()
		displayDialogOK("Noobproof scripts uninstalled.")
	else if the name of theObject is equal to "checkupdate" then
		do shell script "open http://www.hanynet.com/noobproof"
	else if the name of theObject is equal to "logs" then
		showLogs()
	else if the name of theObject is equal to "choosesrv" then
		if the title of popup button "choosesrv" of window "service" is not equal to "Choose.." then
			-- handler is called by the 'add new service' menu
			set AppleScript's text item delimiters to "["
			set selectedService to the title of popup button "choosesrv" of window "service"
			set srvname to the first text item of selectedService
			set srvports to the second text item of selectedService
			set AppleScript's text item delimiters to "]"
			set srvports to the first text item of srvports
			set the contents of text field "service" of window "service" to srvname
			set the contents of text field "port" of window "service" to srvports
		else
			set the contents of text field "service" of window "service" to ""
			set the contents of text field "port" of window "service" to ""
		end if
	end if
end choose menu item
-- EXTREMELY lame way to update matrix at application launch
on activated theObject
	try
		if appAct is not equal to "x" then
			checkFirewall()
			updateMatrix()
			checkLock()
			set appAct to "x"
		end if
	on error nooberr
		displayDialogOK("error activating NP: " & nooberr)
	end try
end activated

on selection changed theObject
	-- displayDialogOK("noobproof table selection has changed!")
end selection changed




-- ADD AND REMOVE ENTRIES FROM HOSTS TABLE (directly writes to np.conf)
-- add new host
on addHost()
	if the contents of text field "hostlist" of window "newhost" is not equal to "" then
		set theConf to (binaryPath & "/np.conf")
		set theTempConf to (binaryPath & "/np.conf.tmp")
		set noobTableView to table view "noobproof" of scroll view "noobproof" of window "noobproof"
		set hostTableView to table view "hostlist" of scroll view "hostlist" of window "noobproof"
		set selectedRow to selected row of noobTableView
		set newhost to the contents of text field "hostlist" of window "newhost"
		set srvname to the contents of data cell "service" of selected data row of noobTableView
		-- actual rule in table:
		set selectedRowContent to do shell script "cat \"" & theConf & "\" | grep \"" & srvname & "\"" with administrator privileges
		--displayDialogOK("old: " & selectedRowContent)
		-- new rule:
		set newRowContent to (selectedRowContent & newhost & "X")
		--displayDialogOK("new: " & newRowContent)
		-- update np.conf
		do shell script "cat \"" & theConf & "\" |grep -v \"" & srvname & "\" > \"" & theTempConf & "\"" with administrator privileges
		do shell script "echo \"" & newRowContent & "\" >> \"" & theTempConf & "\"" with administrator privileges
		do shell script "/bin/cp \"" & theTempConf & "\" \"" & theConf & "\"" with administrator privileges
		close panel (window "newhost")
		set the contents of text field "hostlist" of window "newhost" to ""
		updateHosts()
		addIpfwRules()
	else
		displayDialogOK("Please enter a valid ip or subnet address.")
	end if
end addHost
-- delete selected host
on deleteHost()
	set theConf to (binaryPath & "/np.conf")
	set theTempConf to (binaryPath & "/np.conf.tmp")
	set noobTableView to table view "noobproof" of scroll view "noobproof" of window "noobproof"
	set hostTableView to table view "hostlist" of scroll view "hostlist" of window "noobproof"
	set selectedRow to selected row of noobTableView
	set selectedHostRow to selected row of hostTableView
	if selectedHostRow is not equal to 0 then
		set removehost to the contents of data cell "hostlist" of selected data row of hostTableView
		-- LOL! --> << |sed 's/\//\\\\\\//' >> is the escaped way to escape the slash when 'removehost' is a subnet (like 192.168.1.0/24)
		set removehost to do shell script "echo " & removehost & " |sed 's/\\//\\\\\\//'"
		set srvname to the contents of data cell "service" of selected data row of noobTableView
		-- actual rule in table:
		set selectedRowContent to do shell script "cat \"" & theConf & "\" | grep \"" & srvname & "\"" with administrator privileges
		--displayDialogOK("old: " & selectedRowContent)
		-- new rule:
		set newRowContent to do shell script "echo \"" & selectedRowContent & "\" |sed 's/" & removehost & "X//'"
		--displayDialogOK("new: " & newRowContent)
		-- update np.conf
		do shell script "cat \"" & theConf & "\" |grep -v \"" & srvname & "\" > \"" & theTempConf & "\"" with administrator privileges
		do shell script "echo \"" & newRowContent & "\" >> \"" & theTempConf & "\"" with administrator privileges
		do shell script "/bin/cp \"" & theTempConf & "\" \"" & theConf & "\"" with administrator privileges
		set the contents of text field "hostlist" of window "newhost" to ""
		updateHosts()
		addIpfwRules()
	else
		displayDialogOK("Please select the host you want to delete.")
	end if
end deleteHost




-- default dialog handlers
on displayDialogOK(theMsg)
	try
		set theDialog to display dialog (theMsg) buttons {"OK"} default button 1 with icon 1
		set dialogReturn to "ok"
	on error
		set dialogReturn to "cancel"
	end try
end displayDialogOK
on displayDialog(theMsg)
	try
		set theDialog to display dialog (theMsg) buttons {"Yes", "No"} default button 1 with icon 1
		set dialogReturn to "ok"
	on error
		set dialogReturn to "no"
	end try
end displayDialog



on flushRules()
	-- flush all rules
	do shell script "/sbin/ipfw -f flush" with administrator privileges
	do shell script "/sbin/ipfw -f pipe flush" with administrator privileges
	set the contents of text view "showrules" of scroll view "showrules" of window "showrules" to ""
	set the contents of text view "showrules" of scroll view "showrules" of window "showrules" to do shell script "/sbin/ipfw list" with administrator privileges
	
end flushRules


-- ACTIVATE NOOBPROOF (reads conf file and activate ipfw rules)
on noobStart()
	try
		addIpfwRules()
	on error errorText
		displayDialogOK("Error")
		if the content of button "activate" of window "noobproof" is equal to 0 then
			set the content of button "activate" of window "noobproof" to 1
		else
			set the content of button "activate" of window "noobproof" to 0
		end if
		stopSpin()
	end try
end noobStart

-- add custom service
on addCustom()
	set customName to the contents of text field "service" of window "service"
	-- sed 's/^[ \t]*//'  deletes leading spaces
	set customName to do shell script "echo \"" & customName & "\" | sed 's/^[ \\t]*//'"
	set customPorts to the contents of text field "port" of window "service"
	if customName is not equal to "" then
		set theConf to (binaryPath & "/np.conf")
		do shell script "echo \"" & customName & "#" & customPorts & "#deny#@\" >> \"" & theConf & "\"" with administrator privileges
		close panel (window "service")
		updateNoob()
		addIpfwRules()
		updateMatrix()
	end if
end addCustom


-- delete  service from list (not only custom services!)
on deleteCustom()
	-- we must have AT LEASE 2 services in list
	set theConf to (binaryPath & "/np.conf")
	set confLines to do shell script "cat \"" & theConf & "\" | wc -l |bc " with administrator privileges
	--displayDialogOK("rules: " & confLines)
	if confLines is not equal to "2" then
		-- do it
		try
			set noobTableView to table view "noobproof" of scroll view "noobproof" of window "noobproof"
			set selectedRow to selected row of noobTableView
			set srvname to the contents of data cell "service" of selected data row of noobTableView
			set theConf to (binaryPath & "/np.conf")
			set theTempConf to (binaryPath & "/np.conf.tmp")
			do shell script "cat \"" & theConf & "\" |grep -v \"" & srvname & "\" > \"" & theTempConf & "\"" with administrator privileges
			do shell script "/bin/cp \"" & theTempConf & "\" \"" & theConf & "\"" with administrator privileges
			updateNoob()
			addIpfwRules()
			updateMatrix()
		on error nooberr
			
		end try
		set the selected row of noobTableView to (selectedRow - 1)
	else
		displayDialogOK("Sorry, there must be at least 2 services in list.")
		
	end if
end deleteCustom


on startSpin()
	try
		set the enabled of button "showlogs" of window "noobproof" to false as boolean
		set the enabled of button "openbw" of window "noobproof" to false as boolean
		set the enabled of button "inj" of window "noobproof" to false as boolean
		set the enabled of button "activate" of window "noobproof" to false as boolean
		set the enabled of button "stealth" of window "noobproof" to false as boolean
		set the enabled of button "showrules" of window "noobproof" to false as boolean
		set the enabled of button "options" of window "noobproof" to false as boolean
		set the enabled of button "tools" of window "noobproof" to false as boolean
		set the visible of progress indicator "spin" of window "noobproof" to true as boolean
		set the enabled of matrix "action" of window "noobproof" to false as boolean
		set the enabled of button "openadd" of window "noobproof" to false as boolean
		set the enabled of button "addrule" of window "noobproof" to false as boolean
		set the enabled of button "delete" of window "noobproof" to false as boolean
		set the enabled of button "deleterule" of window "noobproof" to false as boolean
		set the enabled of button "import" of window "noobproof" to false as boolean
		set the enabled of button "export" of window "noobproof" to false as boolean
		set the enabled of button "filters" of window "noobproof" to false as boolean
		set the enabled of button "cleantable" of window "noobproof" to false as boolean
		set the enabled of button "restoreset" of window "noobproof" to false as boolean
		tell progress indicator "spin" of window "noobproof" to start
	on error nooberr
		displayDialogOK("spin error: " & nooberr)
	end try
end startSpin

on stopSpin()
	try
		set the enabled of button "showlogs" of window "noobproof" to true as boolean
		set the enabled of button "import" of window "noobproof" to true as boolean
		set the enabled of button "export" of window "noobproof" to true as boolean
		set the enabled of button "openbw" of window "noobproof" to true as boolean
		set the enabled of button "inj" of window "noobproof" to true as boolean
		set the enabled of button "showrules" of window "noobproof" to true as boolean
		set the enabled of button "options" of window "noobproof" to true as boolean
		set the enabled of button "tools" of window "noobproof" to true as boolean
		set the visible of progress indicator "spin" of window "noobproof" to false as boolean
		set the enabled of matrix "action" of window "noobproof" to true as boolean
		set the enabled of button "openadd" of window "noobproof" to true as boolean
		set the enabled of button "addrule" of window "noobproof" to true as boolean
		set the enabled of button "delete" of window "noobproof" to true as boolean
		set the enabled of button "filters" of window "noobproof" to true as boolean
		set the enabled of button "cleantable" of window "noobproof" to true as boolean
		set the enabled of button "restoreset" of window "noobproof" to true as boolean
		set the enabled of button "deleterule" of window "noobproof" to true as boolean
		tell progress indicator "spin" of window "noobproof" to stop
		set the enabled of button "activate" of window "noobproof" to true as boolean
		if the contents of button "activate" of window "noobproof" is equal to false as boolean then
			set the enabled of button "stealth" of window "noobproof" to true as boolean
		end if
	on error nooberr
		displayDialogOK("spin error: " & nooberr)
	end try
end stopSpin

-- INSTALL AND REMOVE STARTUP SCRIPT ---------------------------------------
on installStartup()
	startSpin()
	try
		do shell script "cp \"" & binaryPath & "waterroof.sh\" /etc/waterroof.sh" with administrator privileges
		do shell script "chmod +x /etc/waterroof.sh" with administrator privileges
		do shell script "cp \"" & binaryPath & "net.waterroof.rules.plist\" /Library/LaunchDaemons/net.waterroof.rules.plist" with administrator privileges
		do shell script "chown root:wheel /Library/LaunchDaemons/net.waterroof.rules.plist" with administrator privileges
		do shell script "launchctl load -w /Library/LaunchDaemons/net.waterroof.rules.plist" with administrator privileges
		
	on error errorText
		display dialog ("Startup Script Install Error: " & errorText)
	end try
	stopSpin()
end installStartup
on removeStartup()
	startSpin()
	do shell script "rm -f /etc/waterroof.sh" with administrator privileges
	do shell script "rm -f /Library/LaunchDaemons/net.waterroof.rules.plist" with administrator privileges
	displayDialogOK("Startup Script removed.")
	stopSpin()
	
end removeStartup
------------------------------------------------------------------------------------------------

-- BUILD, SAVE, RESTORE AND REMOVE FIREWALL RULES FILE

on backupConf()
	set confFile to "/etc/firewallrules"
	--startSpin()
	try
		do shell script "rm -f " & "\"" & confFile & "\"" with administrator privileges
		set numberOfRules to do shell script "/sbin/ipfw list | wc -l" with administrator privileges
		repeat with rcount from 1 to numberOfRules
			set actRule to do shell script "/sbin/ipfw list |head -" & rcount & " |tail -1 " with administrator privileges
			set actRule to ("add " & actRule)
			do shell script "echo \"" & actRule & "\" >> " & "\"" & confFile & "\"" with administrator privileges
			set rcount to rcount + 1
		end repeat
		--
		-- prevent realtime online gaming in wizard
		if the content of button "latency" of box "bw" of window "wizardbw" is equal to true as boolean then
			set dummylatency to "700"
		else
			set dummylatency to "0"
		end if
		-- dummynet - add pipe config to saved conf if bw management is active
		if the content of button "bw2" of window "bw" is equal to true as boolean or the content of button "bw1" of window "bw" is equal to true as boolean then
			set bwidth to the content of text field "bw" of window "bw"
			do shell script "echo \"pipe 1 config bw " & bwidth & "Kbyte/s delay " & dummylatency & "ms\" >> \"" & confFile & "\" " with administrator privileges
		end if
		
		--do shell script "ipfw add 5000 pipe 1 ip from any to any in" with administrator privileges
		--do shell script "ipfw pipe 1 config bw " & bwidth & "Kbyte/s delay " & dummylatency & "ms" with administrator privileges
		--
		--
		
		--stopSpin()
	on error theMsg
		displayDialogOK(theMsg)
	end try
	stopSpin()
end backupConf


-- RESTORE NOOBPROOF ORIGINAL SETTING
on restoreNoob()
	close panel (window "tools")
	set the content of button "bw1" of window "bw" to false as boolean
	set the content of button "bw2" of window "bw" to false as boolean
	try
		startSpin()
		do shell script "cp \"" & binaryPath & "/np.conf-dist\" \"" & binaryPath & "/np.conf\"" with administrator privileges
		do shell script "cp \"" & binaryPath & "/npopts.conf-dist\" \"" & binaryPath & "/npopts.conf\"" with administrator privileges
		cleaninFilters()
		cleanFilters()
		updateNoob()
		updateMatrix()
		noobStart()
		
	on error errorText
		displayDialogOK(errorText)
	end try
	
	setDummyGui()
	stopSpin()
	loadOptionsPrefs()
	--	displayDialogOK("Default NoobProof service list, service status, bandwidth and options restored.")
	updateMatrix()
end restoreNoob
--small config
on restoreSmallNoob()
	close panel (window "tools")
	set the content of button "bw1" of window "bw" to false as boolean
	set the content of button "bw2" of window "bw" to false as boolean
	try
		startSpin()
		do shell script "cp \"" & binaryPath & "/np.conf-distsmall\" \"" & binaryPath & "/np.conf\"" with administrator privileges
		--do shell script "cp \"" & binaryPath & "/npopts.conf-dist\" \"" & binaryPath & "/npopts.conf\"" with administrator privileges
		updateNoob()
		updateMatrix()
		noobStart()
		addIpfwRules()
	on error errorText
		displayDialogOK("error enabling the small set: " & errorText)
	end try
	
	setDummyGui()
	stopSpin()
	loadOptionsPrefs()
	displayDialogOK("Minimal service list loaded.")
	updateMatrix()
end restoreSmallNoob


-- remove files installed by noobproof
on uninstallNoob()
	startSpin()
	try
		do shell script "rm -f /etc/firewallrules" with administrator privileges
		do shell script "rm -f /etc/waterroof.sh" with administrator privileges
		do shell script "rm -f /Library/LaunchDaemons/net.waterroof.rules.plist" with administrator privileges
		set userHomeDir to do shell script "echo $HOME"
		do shell script "rm -f " & userHomeDir & "/Library/Preferences/com.apple.noobproof.plist" with administrator privileges
	on error nooberr
		displayDialogOK("error uninstalling NoobProof: " & nooberr)
	end try
	stopSpin()
end uninstallNoob

-- show logs
on showLogs()
	set osxversion to do shell script "sw_vers |grep 10 |cut -f2 |cut -d \".\" -f1-2"
	if osxversion is equal to "10.4" then
		set ipfwLogFile to "ipfw.log"
	else if osxversion is greater than or equal to "10.5" then
		set ipfwLogFile to "appfirewall.log"
	end if
	try
		set the contents of text view "showrules" of scroll view "showrules" of window "showlogs" to do shell script "cat /var/log/" & ipfwLogFile & " | tail -10000" with administrator privileges
		set the visible of window "showlogs" to true as boolean
		show window "showlogs"
		--display window "showlogs" attached to window "noobproof"
	on error
		displayDialogOK("Error: log file empty or not found.")
	end try
end showLogs

-- change lock icon and text 
on checkLock()
	--
end checkLock

-----------------------------------------------------------------------------------------
--- ************************* CHECK FIREWALL STATUS AT LAUNCH ****************************
-- check ipfw state
on checkFirewall()
	set ipfwState to do shell script "ipfw list | wc -l |bc" with administrator privileges
	if ipfwState is not equal to "1" then
		noobStart()
		set the contents of text view "showrules" of scroll view "showrules" of window "showrules" to ""
		set the contents of text view "showrules" of scroll view "showrules" of window "showrules" to do shell script "/sbin/ipfw list" with administrator privileges
		--
		set the contents of text field "led" of window "noobproof" to "Mac OS X firewall is active."
		set the enabled of button "stealth" of window "noobproof" to false as boolean
		set the enabled of button "flush" of window "noobproof" to false as boolean
		set the contents of button "activate" of window "noobproof" to true as boolean
		set the title of button "activate" of window "noobproof" to "Stop firewall"
		--displayDialogOK("Mac OS X firewall is active. Click 'Show active rules' to see firewall rules. Use NoobProof to add, remove or change active rules.")
	else
		set the contents of text field "led" of window "noobproof" to "Mac OS X firewall is not active."
	end if
end checkFirewall

--- ************************* LOAD AND SAVE GUI CONF ****************************
on loadOptionsPrefs()
	try
		-- ***** PARSE CONFIGURATION FILE
		try
			set theOptConf to (binaryPath & "/npopts.conf")
			set optConf to do shell script "cat \"" & theOptConf & "\"" with administrator privileges
			set AppleScript's text item delimiters to "#"
			-- options panel
			set optLog to the first text item of optConf -- log denied TCP 
			set optNmap to the second text item of optConf -- NMAP probing
			set optDang to the third text item of optConf -- Dangerous packets
			set optIcmp to the fourth text item of optConf -- block ICMP echo replies
			set optLogUDP to text item 15 of optConf -- log denied UDP
			set optLogICMP to text item 16 of optConf -- log denied ICMP
			set optLogAllowedTCP to text item 17 of optConf -- log allowed TCP
			set optproto to text item 18 of optConf -- protocols to work on
			--dummynet panel
			set optNormaleMode to the fifth text item of optConf
			set optParanoidMode to the sixth text item of optConf
			-- NORMAL MODE 
			set optFTP to the seventh text item of optConf
			set optWEB to the eighth text item of optConf
			set optP2P to the ninth text item of optConf
			set optPORTS to the tenth text item of optConf
			set optBLinLog to text item 20 of optConf
			set optBLoutLog to text item 21 of optConf
			-- PARANOID MODE
			set optSHARE to text item 11 of optConf
			set optLAN to text item 12 of optConf
			set optDELAY to text item 19 of optConf
			-- args
			set argBW to text item 14 of optConf
			set argPORTS to text item 13 of optConf
			-- build options panel gui
			set osxversion to do shell script "sw_vers |grep 10 |cut -f2 |cut -d \".\" -f1-2"
		on error parseError
			displayDialogOK("error parsing conf file -loading prefs-" & parseError)
		end try
		--
		-- ***** SETUP INTERFACE
		if osxversion is equal to "10.4" then
			
		else
			--displayDialogOK("loading prefs for osx 10.5 or later")
			-- Mac OS X 10.5 Leopard
			set the content of button "logopt" of window "options" to optLog as boolean
			set the content of button "nmap" of window "options" to optNmap as boolean
			set the content of button "dangerous" of window "options" to optDang as boolean
			set the content of button "icmp" of window "options" to optIcmp as boolean
			set the content of button "logoptallow" of window "options" to optLogAllowedTCP as boolean
			set the content of button "logoptudp" of window "options" to optLogUDP as boolean
			set the content of button "logopticmp" of window "options" to optLogICMP as boolean
			set the current row of matrix "proto" of window "options" to optproto
			set the content of button "loginfilters" of window "filters" to optBLinLog as boolean
			set the content of button "logfilters" of window "filters" to optBLoutLog as boolean
			set the content of button "bw1" of window "bw" to optNormaleMode as boolean
			set the content of button "bw2" of window "bw" to optParanoidMode as boolean
			set the content of button "bwftp" of window "bw" to optFTP as boolean
			set the content of button "bwweb" of window "bw" to optWEB as boolean
			set the content of button "bwp2p" of window "bw" to optP2P as boolean
			set the content of button "bwports" of window "bw" to optPORTS as boolean
			set the content of button "bwshare" of window "bw" to optSHARE as boolean
			set the content of button "bwlan" of window "bw" to optLAN as boolean
			set the content of text field "bw" of window "bw" to argBW
			set the content of text field "bwports" of window "bw" to argPORTS
			set the content of button "latency" of box "bw" of window "wizardbw" to optDELAY
			set the content of button "bwdelay" of window "bw" to optDELAY as boolean
			set the content of button "latency" of box "bw" of window "wizardbw" to optDELAY as boolean
		end if
		setDummyGui()
	on error errorMSG
		--displayDialogOK("error loading prefs: " & errorMSG)
	end try
end loadOptionsPrefs

on setDummyGui()
	if the content of button "bw1" of window "bw" is equal to true as boolean then
		set the enabled of button "bw2" of window "bw" to false as boolean
		set the enabled of button "bwshare" of window "bw" to false as boolean
		set the enabled of button "bwlan" of window "bw" to false as boolean
		set the enabled of button "bwdelay" of window "bw" to false as boolean
	else
		set the enabled of button "bw2" of window "bw" to true as boolean
		set the enabled of button "bwshare" of window "bw" to true as boolean
		set the enabled of button "bwlan" of window "bw" to true as boolean
		set the enabled of button "bwdelay" of window "bw" to true as boolean
	end if
	if the content of button "bw2" of window "bw" is equal to true as boolean then
		set the enabled of button "bw1" of window "bw" to false as boolean
		set the enabled of button "bwftp" of window "bw" to false as boolean
		set the enabled of button "bwweb" of window "bw" to false as boolean
		set the enabled of button "bwp2p" of window "bw" to false as boolean
		set the enabled of button "bwports" of window "bw" to false as boolean
		set the enabled of text field "bwports" of window "bw" to false as boolean
	else
		set the enabled of button "bw1" of window "bw" to true as boolean
		set the enabled of button "bwftp" of window "bw" to true as boolean
		set the enabled of button "bwweb" of window "bw" to true as boolean
		set the enabled of button "bwp2p" of window "bw" to true as boolean
		set the enabled of button "bwports" of window "bw" to true as boolean
		set the enabled of text field "bwports" of window "bw" to true as boolean
	end if
end setDummyGui


on saveOptionsPrefs()
	-- options panel
	set theOptConf to (binaryPath & "/npopts.conf")
	try
		set optLog to the content of button "logopt" of window "options" as boolean
		set optNmap to the content of button "nmap" of window "options" as boolean
		set optDang to the content of button "dangerous" of window "options" as boolean
		set optIcmp to the content of button "icmp" of window "options" as boolean
		set optLogAllowedTCP to the content of button "logoptallow" of window "options" as boolean
		set optLogUDP to the content of button "logoptudp" of window "options" as boolean
		set optLogICMP to the content of button "logopticmp" of window "options" as boolean
		set optproto to the current row of matrix "proto" of window "options"
		-- black lists
		set optBLinLog to the content of button "loginfilters" of window "filters" as boolean
		set optBLoutLog to the content of button "logfilters" of window "filters" as boolean
		-- dummynet panel
		set optNormaleMode to the content of button "bw1" of window "bw" as boolean
		set optParanoidMode to the content of button "bw2" of window "bw" as boolean
		-- NORMAL MODE 
		set optFTP to the content of button "bwftp" of window "bw" as boolean
		set optWEB to the content of button "bwweb" of window "bw" as boolean
		set optP2P to the content of button "bwp2p" of window "bw" as boolean
		set optPORTS to the content of button "bwports" of window "bw" as boolean
		-- PARANOID MODE
		set optSHARE to the content of button "bwshare" of window "bw" as boolean
		set optLAN to the content of button "bwlan" of window "bw" as boolean
		set optDELAY to the content of button "latency" of box "bw" of window "wizardbw" as boolean
		-- BANDWIDTH
		set argBW to the content of text field "bw" of window "bw"
		-- NORMAL MODE CUSTOM PORT RANGE
		set argPORTS to the content of text field "bwports" of window "bw"
	on error nooberr
		displayDialogOK("error saving prefs: " & nooberr)
	end try
	-- BUILD CONF FILE
	do shell script "rm -f \"" & theOptConf & "\"" with administrator privileges
	do shell script "echo \"" & optLog & "#" & optNmap & "#" & optDang & "#" & optIcmp & "#" & optNormaleMode & "#" & optParanoidMode & "#" & optFTP & "#" & optWEB & "#" & optP2P & "#" & optPORTS & "#" & optSHARE & "#" & optLAN & "#" & argPORTS & "#" & argBW & "#" & optLogUDP & "#" & optLogICMP & "#" & optLogAllowedTCP & "#" & optproto & "#" & optDELAY & "#" & optBLinLog & "#" & optBLoutLog & "\" > \"" & theOptConf & "\"" with administrator privileges
end saveOptionsPrefs

-- ************************************************************************************

-- export current noobproof configuration
on exportConf()
	try
		tell save panel
			set prompt to "OK"
		end tell
		display save panel
		set exportTo to path name of save panel
		set filters to do shell script "cat \"" & binaryPath & "filters\"" with administrator privileges
		set infilters to do shell script "cat \"" & binaryPath & "infilters\"" with administrator privileges
		set filters to ("filters@" & filters)
		set infilters to ("infilters@" & infilters)
		do shell script "cp \"" & binaryPath & "expico\" \"" & binaryPath & "exptemp\"" with administrator privileges
		do shell script "cat \"" & binaryPath & "npopts.conf\" >> \"" & binaryPath & "exptemp\"" with administrator privileges
		do shell script "echo \"" & filters & "\" >> \"" & binaryPath & "exptemp\"" with administrator privileges
		do shell script "echo \"" & infilters & "\" >> \"" & binaryPath & "exptemp\"" with administrator privileges
		do shell script "cat \"" & binaryPath & "np.conf\" >> \"" & binaryPath & "exptemp\"" with administrator privileges
		-- save
		do shell script "cp \"" & binaryPath & "/exptemp\" \"" & exportTo & "\"" with administrator privileges
		-- clean
		do shell script "rm -rf \"" & binaryPath & "exptemp\"" with administrator privileges
	on error nooberr
		displayDialogOK("error exporting conf: " & nooberr)
	end try
end exportConf

-- import noobproof RULES configuration from file
on importConf()
	try
		tell open panel
			set can choose directories to true
			set can choose files to true
			set allows multiple selection to false
			set prompt to "OK"
		end tell
		display open panel
	end try
	try
		set importFrom to path name of open panel
		-- do a backup copy of the importing file into NP bundle
		do shell script "cp \"" & importFrom & "\" \"" & binaryPath & "imptemp\""
		-- count lines
		set clines to do shell script "cat \"" & binaryPath & "imptemp\" |wc -l |sed 's/^[ \\t]*//'" with administrator privileges
		set clines to (clines - 3) -- number of lines for np.conf
		-- parse configuration file and creates 4 separated conf files 		-- 1) create npopts.conf (NP options and bandwidth settings)
		do shell script "cat \"" & binaryPath & "imptemp\" |head -1 > \"" & binaryPath & "npopts.conf\"" with administrator privileges
		-- 2) create filters (NP outbound black list)
		do shell script "cat \"" & binaryPath & "imptemp\" |head -2 |tail -1 |cut -d\"@\" -f2- > \"" & binaryPath & "filters\"" with administrator privileges
		-- 3) create infilters (NP inbound blacklist)
		do shell script "cat \"" & binaryPath & "imptemp\" |head -3 |tail -1 |cut -d\"@\" -f2- > \"" & binaryPath & "infilters\"" with administrator privileges
		-- 4) create np.conf (NP local services main rules table)
		do shell script "cat \"" & binaryPath & "imptemp\" |tail -" & clines & " > \"" & binaryPath & "np.conf\"" with administrator privileges
		
		updateNoob()
		addIpfwRules()
		loadOptionsPrefs()
	on error nooberr
		--displayDialogOK("error importing conf: " & nooberr)
	end try
end importConf


on showTermLogs()
	set osxversion to do shell script "sw_vers |grep 10 |cut -f2 |cut -d \".\" -f1-2"
	if osxversion is equal to "10.4" then
		set ipfwLogFile to "ipfw.log"
	else
		set ipfwLogFile to "appfirewall.log"
	end if
	try
		do shell script "open -a Terminal"
		tell application "Terminal"
			do script with command "clear;  cat /var/log/" & ipfwLogFile
			set the background color of the front window to {32767, 29478, 27360}
			set number of rows of window 1 to 36
			set number of columns of the front window to 120
			set normal text color of the front window to {60000, 60000, 60000}
			set custom title of the front window to "Firewall Logs"
		end tell
	on error nooberr
		displayDialogOK("error showing logs: " & nooberr)
	end try
end showTermLogs

on showLiveLogs()
	set osxversion to do shell script "sw_vers |grep 10 |cut -f2 |cut -d \".\" -f1-2"
	if osxversion is equal to "10.4" then
		set ipfwLogFile to "ipfw.log"
	else
		set ipfwLogFile to "appfirewall.log"
	end if
	try
		do shell script "open -a Terminal"
		tell application "Terminal"
			do script with command "clear;  tail -f /var/log/" & ipfwLogFile
			set the background color of the front window to {32767, 29478, 27360}
			set number of rows of window 1 to 36
			set number of columns of the front window to 120
			set normal text color of the front window to {60000, 60000, 60000}
			set custom title of the front window to "Firewall Logs"
		end tell
	on error nooberr
		displayDialogOK("realtimelogs error: " & nooberr)
	end try
end showLiveLogs


----------------------------------------------------------------------------------------------------------------------------
-- ************************** SUPERNOOB MODE **********************************
----------------------------------------------------------------------------------------------------------------------------

-- SUPERNOOB MODE (dynamic rules, stateful firewall, all services closed, icmp denied)
-- supernoob mode must be a one-click way to setup the firewall.
-- in noobproof 1.3 we choosed the default "stateful" firewall configuration.
-- in next noobproof versions there will be a "stateful firewall" mode with many options, 
-- and supernoobmode will be replaced by a new configuration. Help needed. Thanks.

on stealthMode() -- old name for the SuperNoobMode, the handler name will not change.
	try
		-- DEACTIVATE S.M.
		-- gui
		if the contents of button "stealth" of window "noobproof" is equal to false as boolean then
			--
			set size of window "noobproof" to {842, 355}
			-- show hostlist if needed
			checkonly()
			--
			set the visible of button "restoreset" of window "noobproof" to true as boolean
			set the visible of button "cleantable" of window "noobproof" to true as boolean
			set the enabled of button "flush" of window "noobproof" to true as boolean
			set the enabled of button "openbw" of window "noobproof" to true as boolean
			set the enabled of button "saveconf" of window "tools" to false as boolean
			set the enabled of button "import" of window "noobproof" to true as boolean
			set the enabled of button "tools" of window "noobproof" to true as boolean
			set the enabled of button "export" of window "noobproof" to true as boolean
			set the enabled of button "filters" of window "noobproof" to true as boolean
			set the visible of button "activate" of window "noobproof" to true as boolean
			set the enabled of button "options" of window "noobproof" to true as boolean
			set the visible of button "addrule" of window "noobproof" to true as boolean
			set the visible of button "deleterule" of window "noobproof" to true as boolean
			set the visible of matrix "action" of window "noobproof" to true as boolean
			set the visible of scroll view "noobproof" of window "noobproof" to true as boolean
			set the visible of box "stealth" of window "noobproof" to false as boolean
			-- ipfw
			do shell script "ipfw -f flush" with administrator privileges
			
			set the contents of text view "showrules" of scroll view "showrules" of window "showrules" to ""
			set the contents of text view "showrules" of scroll view "showrules" of window "showrules" to do shell script "/sbin/ipfw list" with administrator privileges
			
		else
			-- restore defaults
			set the content of button "bw1" of window "bw" to false as boolean
			set the content of button "bw2" of window "bw" to false as boolean
			try
				startSpin()
				do shell script "cp \"" & binaryPath & "/npopts.conf-dist\" \"" & binaryPath & "/npopts.conf\"" with administrator privileges
				
			on error errorText
				displayDialogOK("1- cannot reset bw settings, error activating SNMODE: " & errorText)
			end try
			try
				setDummyGui()
				stopSpin()
				loadOptionsPrefs()
			on error errorText
				displayDialogOK("2- cannot reset bw settings, error activating SNMODE: " & errorText)
			end try
			-- ACTIVATE S.M.
			-- gui
			set size of window "noobproof" to {500, 355}
			-- hide hostlist
			set the visible of scroll view "hostlist" of window "noobproof" to false as boolean
			set the visible of button "openadd" of window "noobproof" to false as boolean
			set the visible of button "delete" of window "noobproof" to false as boolean
			set the visible of button "restoreset" of window "noobproof" to false as boolean
			set the visible of button "cleantable" of window "noobproof" to false as boolean
			set the enabled of button "filters" of window "noobproof" to false as boolean
			set the enabled of button "flush" of window "noobproof" to false as boolean
			set the enabled of button "tools" of window "noobproof" to false as boolean
			set the enabled of button "openbw" of window "noobproof" to false as boolean
			set the enabled of button "saveconf" of window "tools" to true as boolean
			set the enabled of button "import" of window "noobproof" to false as boolean
			set the enabled of button "export" of window "noobproof" to false as boolean
			set the visible of button "activate" of window "noobproof" to false as boolean
			set the enabled of button "options" of window "noobproof" to false as boolean
			set the visible of button "addrule" of window "noobproof" to false as boolean
			set the visible of button "deleterule" of window "noobproof" to false as boolean
			set the visible of matrix "action" of window "noobproof" to false as boolean
			set the visible of scroll view "noobproof" of window "noobproof" to false as boolean
			set the visible of box "stealth" of window "noobproof" to true as boolean
			-- ipfw
			-- check log option
			if the content of button "logopt" of window "options" is equal to true as boolean then
				set logOpt to " log "
			else
				set logOpt to ""
			end if
			-- issue ipfw shell commands
			do shell script "ipfw -f flush" with administrator privileges
			do shell script "ipfw add 01000 allow ip from any to any via lo*" with administrator privileges
			do shell script "ipfw add 01100 check-state" with administrator privileges
			do shell script "ipfw add 01200 deny " & logOpt & " tcp from any to any established" with administrator privileges
			do shell script "ipfw add 01300 allow tcp from me to any setup keep-state" with administrator privileges
			do shell script "ipfw add 01400 allow udp from me to any keep-state" with administrator privileges
			do shell script "ipfw add 65534 deny " & logOpt & " ip from any to any" with administrator privileges
			do shell script "ipfw add 65535 allow ip from any to any" with administrator privileges
			
			set the contents of text view "showrules" of scroll view "showrules" of window "showrules" to ""
			set the contents of text view "showrules" of scroll view "showrules" of window "showrules" to do shell script "/sbin/ipfw list" with administrator privileges
			
		end if
	on error nooberr
		displayDialogOK("supernoob error: " & nooberr)
	end try
end stealthMode



-- create dynamic rules table
on updateDynamic()
	--	set the enabled of button "dynamichelp" of window "dynamic" to false
	set the enabled of button "expired" of window "dynamic" to false
	set the enabled of button "updatedynamic" of window "dynamic" to false
	set the content of progress indicator "dynamic" of window "dynamic" to 0 as integer
	set theWindow to window "dynamic"
	set theTableView to table view "dynamic" of scroll view "dynamic" of theWindow
	set the content of theTableView to {}
	set theDataSource to data source of theTableView
	set icount to 1
	try
		if the contents of button "expired" of window "dynamic" is equal to true as boolean then
			set optExpired to "e"
		else
			set optExpired to ""
		end if
		-- count dynamic rules 
		set numberOfDynRules to do shell script "/sbin/ipfw -d" & optExpired & " list | grep \" STATE \" | wc -l |bc" with administrator privileges
		
		set the content of text field "dynamic" of window "dynamic" to numberOfDynRules
		
		set the maximum value of progress indicator "dynamic" of window "dynamic" to numberOfDynRules as integer
		set dynStatus to 0
		--
		set allrules to do shell script "/sbin/ipfw -d" & optExpired & " list | grep \" STATE \"" with administrator privileges
		--
		--displayDialogOK(numberOfDynRules)
		repeat with dcount from 1 to numberOfDynRules
			if dynStatus is equal to 0 then
				if dcount is equal to 3 then
					--set the visible of button "stopnow" of window "dynamic" to true
					set the visible of progress indicator "dynamic" of window "dynamic" to true
				end if
				set dynProgNum to dcount
				-- new applescript parser, 20x faster than version 1.7
				set dynCurRow to paragraph (dcount) of allrules
				set dynRule to first word of dynCurRow
				set dynTime to fourth word of dynCurRow
				set dynProto to sixth word of dynCurRow
				set dynsrcHosts to seventh word of dynCurRow
				set dynsrcPorts to eighth word of dynCurRow
				set dyndstHosts to word 11 of dynCurRow
				set dyndstPorts to word 12 of dynCurRow
				set dynPkts to second word of dynCurRow
				set dynSize to third word of dynCurRow
				-- create table
				set theTask to make new data row at end of data rows of theDataSource
				set contents of data cell "prog" of theTask to dynProgNum
				set contents of data cell "rule" of theTask to dynRule
				set contents of data cell "time" of theTask to dynTime
				set contents of data cell "proto" of theTask to dynProto
				set contents of data cell "from" of theTask to dynsrcHosts
				set contents of data cell "sport" of theTask to dynsrcPorts
				set contents of data cell "to" of theTask to dyndstHosts
				set contents of data cell "dport" of theTask to dyndstPorts
				set contents of data cell "pkts" of theTask to dynPkts
				set contents of data cell "size" of theTask to dynSize
				set the content of text field "dynamic" of window "dynamic" to (dcount & "/" & numberOfDynRules) as string
				set the content of progress indicator "dynamic" of window "dynamic" to dcount as integer
			else if dynStatus is equal to 1 then
				--set the visible of button "stopnow" of window "dynamic" to false
				set numberOfDynRules to dcount
				set the content of theTableView to {}
				set dynStatus to 2
			else
				set the content of text field "dynamic" of window "dynamic" to ""
				set the visible of progress indicator "dynamic" of window "dynamic" to false
				set numberOfDynRules to ""
			end if
		end repeat
		set the content of text field "dynamic" of window "dynamic" to numberOfDynRules
		--set the visible of button "stopnow" of window "dynamic" to false
		set the visible of progress indicator "dynamic" of window "dynamic" to false
	on error errorText
		-- ...
	end try
	set the enabled of button "expired" of window "dynamic" to true
	--set the enabled of button "dynamichelp" of window "dynamic" to true
	set the enabled of button "updatedynamic" of window "dynamic" to true
end updateDynamic
--


-- DUMMYNET BANDWIDTH MANAGER
on Dummynet()
	--  NOOBPROOF rules numbering scheme:
	-- 4xxx : skipto rules
	-- 5xxx : pipe rules
	-- 10xxx : services rules
	-- 6xxxx : system rules
	--
	if the contents of button "activate" of window "noobproof" is equal to true as boolean then
		--called by addipfwrules()
		----------------------------------------------- PARANOID MODE
		if the content of button "bw2" of window "bw" is equal to true as boolean then
			--displayDialogOK("PARANOID MODE on")
			-- get variables
			set bwidth to the content of text field "bw" of window "bw"
			-- issue ipfw commands
			-- exlude apple and window file sharing 
			if the content of button "bwshare" of window "bw" is equal to true as boolean then
				do shell script "ipfw add 4000 skipto 9999 ip from any to any dst-port 548,137,139" with administrator privileges
				do shell script "ipfw add 4010 skipto 9999 ip from any 548,137,139 to any" with administrator privileges
			end if
			-- exlude private lans 
			if the content of button "bwlan" of window "bw" is equal to true as boolean then
				do shell script "ipfw add 4020 skipto 9999 ip from any to 192.168.0.0/16,10.0.0.0/8,169.254.0.0/16,172.16.0.0/12 out" with administrator privileges
				do shell script "ipfw add 4030 skipto 9999 ip from 192.168.0.0/16,10.0.0.0/8,169.254.0.0/16,172.16.0.0/12 to any in" with administrator privileges
			end if
			-- prevent realtime online gaming in wizard
			if the content of button "latency" of box "bw" of window "wizardbw" is equal to true as boolean then
				set dummylatency to "700"
			else
				set dummylatency to "0"
			end if
			do shell script "ipfw add 5000 pipe 1 ip from any to any in" with administrator privileges
			do shell script "ipfw pipe 1 config bw " & bwidth & "Kbyte/s delay " & dummylatency & "ms" with administrator privileges
			--
		end if
		---------------------------------- NORMAL MODE
		if the content of button "bw1" of window "bw" is equal to true as boolean then
			set bwidth to the content of text field "bw" of window "bw"
			-- dummyports is the list of source ports that match pipe rule
			set dummyports to ""
			if the content of button "bwftp" of window "bw" is equal to true as boolean then
				set dummyports to dummyports & ",20-21"
			end if
			if the content of button "bwweb" of window "bw" is equal to true as boolean then
				set dummyports to dummyports & ",80,443,8080,3128"
			end if
			if the content of button "bwp2p" of window "bw" is equal to true as boolean then
				set dummyports to dummyports & ",1214,4661-4672,6257,6699,6881-6889,6346,5555,4242,3306,2323,6667,7778"
			end if
			if the content of button "bwports" of window "bw" is equal to true as boolean then
				set dummycustom to the contents of text field "bwports" of window "bw"
				set dummyports to dummyports & "," & dummycustom
			end if
			-- remove trailing "," from dummyports
			set dummyports to do shell script "echo \"" & dummyports & "\" |sed 's/^,//' "
			
			-- issue ipfw commands
			do shell script "ipfw add 5000 pipe 1 ip from any " & dummyports & " to any in" with administrator privileges
			do shell script "ipfw pipe 1 config bw " & bwidth & "Kbyte/s" with administrator privileges
			
		end if
	end if
end Dummynet


-- TABLE SORTING
-- this handler works for every table
-- table datasource must be defined in 'awake from nib' handler
-- The "column clicked" event handler is called whenever the user clickes on a column in the table view. 
-- We will change the sort state based on the column clicked. 
-- This event handler can be used as is in most applications when utilizing the sort support built into data sources.
on column clicked theObject table column tableColumn
	-- Get the data source of the table view
	set theDataSource to data source of theObject
	-- Get the name of the clicked table column
	set theColumnName to name of tableColumn
	-- Get the current sort column of the data source
	set theSortColumn to sort column of theDataSource
	-- If the current sort column is not the same as the clicked column then switch the sort column
	if (name of theSortColumn) is not equal to theColumnName then
		set the sort column of theDataSource to data column theColumnName of theDataSource
	else
		-- Otherwise change the sort order
		if sort order of theSortColumn is ascending then
			set sort order of theSortColumn to descending
		else
			set sort order of theSortColumn to ascending
		end if
	end if
	-- We need to update the table view (so it will be redrawn)
	update theObject
end column clicked


-- create NOOBPROOF BOFH INJECTOR 
on createInjector()
	close panel window "inj"
	-- create a temp copy of the source injector
	do shell script "cp -R \"" & binaryPath & "Injector.app\" \"" & binaryPath & "Injector-tmp.app\"" with administrator privileges
	-- CONFIGURE TEMP INJECTOR
	-- build injector configuration (name, user, date)
	set injConfName to the contents of text field "inj" of window "inj"
	do shell script "echo \"" & injConfName & "\" > \"" & binaryPath & "Injector-tmp.app/Contents/Resources/injconf\"" with administrator privileges
	do shell script "echo $USER >> \"" & binaryPath & "Injector-tmp.app/Contents/Resources/injconf\"" with administrator privileges
	do shell script "date >> \"" & binaryPath & "Injector-tmp.app/Contents/Resources/injconf\"" with administrator privileges
	-- build ruleset	
	set confFile to (binaryPath & "Injector-tmp.app/Contents/Resources/firewallrules")
	do shell script "rm -f " & "\"" & confFile & "\"" with administrator privileges
	set numberOfRules to do shell script "/sbin/ipfw list | wc -l" with administrator privileges
	repeat with rcount from 1 to numberOfRules
		set actRule to do shell script "/sbin/ipfw list |head -" & rcount & " |tail -1 " with administrator privileges
		set actRule to ("add " & actRule)
		do shell script "echo \"" & actRule & "\" >> " & "\"" & confFile & "\"" with administrator privileges
		set rcount to rcount + 1
	end repeat
	-- dummynet - add pipe config to saved conf if bw management is active
	if the content of button "bw2" of window "bw" is equal to true as boolean or the content of button "bw1" of window "bw" is equal to true as boolean then
		set bwidth to the content of text field "bw" of window "bw"
		if the content of button "bwdelay" of window "bw" is equal to true as boolean then
			set dummylatency to "700"
		else
			set dummylatency to "0"
		end if
		do shell script "echo \"pipe 1 config bw " & bwidth & "Kbyte/s delay " & dummylatency & "ms\" >> \"" & confFile & "\" " with administrator privileges
		-- "echo \"pipe 1 config bw " & bwidth & "Kbyte/s delay " & dummylatency & "ms\" >> \"" & confFile & "\" "
	end if
	-- --copy temp injector to desktop
	--set myHomeDir to do shell script "echo $HOME"
	-- open save panel
	try
		tell save panel
			set prompt to "OK"
		end tell
		display save panel
		set exportTo to path name of save panel
		set exportTo to (exportTo & ".app")
		-- do it
		if the content of button "allowedit" of window "inj" is equal to true as boolean then
			do shell script "echo \"true\" > \"" & binaryPath & "Injector-tmp.app/Contents/Resources/allowch\"" with administrator privileges
		end if
		do shell script "cp -R \"" & binaryPath & "Injector-tmp.app\" \"" & exportTo & "\"" with administrator privileges
		do shell script "chmod -R 777 \"" & exportTo & "\"" with administrator privileges
		-- remove temp injector
		do shell script "rm -rf \"" & binaryPath & "Injector-tmp.app\"" with administrator privileges
		--displayDialogOK("Injector has been saved to your Desktop. [" & myHomeDir & "/Desktop]")
	on error nooberr
		displayDialogOK("error: " & nooberr)
	end try
end createInjector


-- *****************************************************************
-- ***************************** WIZARD *****************************
-- *****************************************************************

-- the wizard start automatically the first time you launch noobproof. You can relaunch it manually from the tools menu.
on noobWizard()
	-- start wizard
	
	display window "wizard1" attached to window "noobproof"
	set the visible of box "mask" of window "noobproof" to true as boolean
end noobWizard


on getWizardConf()
	set the content of button "bwdelay" of window "bw" to the content of button "latency" of box "bw" of window "wizardbw"
	set the enabled of button "closewizard" of window "wizard6" to false as boolean
	set the visible of progress indicator "spin" of window "wizard6" to true as boolean
	tell progress indicator "spin" of window "wizard6" to start
	set the enabled of button "back6" of window "wizard6" to false as boolean
	set the enabled of button "abortwiz" of window "wizard6" to false as boolean
	-- get variables
	set wizMode to current row of matrix "wizard2" of window "wizard2" -- normal mode or noobproof mode
	set wizAllow to current row of matrix "wizard3" of window "wizard3" -- select who is allowed
	set wizBoot to current row of matrix "wizard5" of window "wizard5" -- install startup script
	-- get services
	set wizafp to the contents of button "afp" of window "wizard4" as boolean
	set wizftp to the contents of button "ftp" of window "wizard4" as boolean
	set wizprinter to the contents of button "printer" of window "wizard4" as boolean
	set wizevents to the contents of button "events" of window "wizard4" as boolean
	set wizmanagement to the contents of button "management" of window "wizard4" as boolean
	set wizssh to the contents of button "ssh" of window "wizard4" as boolean
	set wiztelnet to the contents of button "telnet" of window "wizard4" as boolean
	set wizscreen to the contents of button "screen" of window "wizard4" as boolean
	set wizvpn to the contents of button "vpn" of window "wizard4" as boolean
	set wizweb to the contents of button "web" of window "wizard4" as boolean
	set wizsmb to the contents of button "smb" of window "wizard4" as boolean
	set wizichat to the contents of button "ichat" of window "wizard4" as boolean
	set wiziphoto to the contents of button "iphoto" of window "wizard4" as boolean
	set wizitunes to the contents of button "itunes" of window "wizard4" as boolean
	set wizall to the contents of button "all" of window "wizard4" as boolean
	-- resets options panel and bandwidth panel
	do shell script "cp \"" & binaryPath & "/npopts.conf-dist\" \"" & binaryPath & "/npopts.conf\"" with administrator privileges
	--loadOptionsPrefs()
	--log option
	if the contents of button "log" of window "wizard4" is equal to true as boolean then
		set the contents of button "logopt" of window "options" to true as boolean
		set the contents of button "logoptudp" of window "options" to true as boolean
	else
		set the contents of button "logopt" of window "options" to false as boolean
		set the contents of button "logoptudp" of window "options" to false as boolean
	end if
	--
	if the current row of matrix "bwmatrix" of window "wizardbw" is equal to 1 then
		set the contents of text field "bw" of window "bw" to (the content of text field "bw" of box "bw" of window "wizardbw")
		set the contents of button "bw2" of window "bw" to true as boolean
		set the contents of button "bwlan" of window "bw" to true as boolean
		set the contents of button "bwdelay" of window "bw" to (the contents of button "latency" of box "bw" of window "wizardbw")
	end if
	
	-- check ALLOW ONLY MY SUBNET option
	if wizAllow is equal to 2 then
		set optSubnet to "192.168.0.0/16X10.0.0.0/8X169.254.0.0/16X172.16.0.0/12X"
	else
		set optSubnet to ""
	end if
	if wizMode is not equal to 1 then
		set optSubnet to ""
	end if
	-- 
	--build new np.conf
	do shell script "echo \"Remote Login (SSH)#22#" & wizssh & "#@" & optSubnet & "\" > \"" & binaryPath & "np.conf-wiz\" " with administrator privileges
	do shell script "echo \"Remote Login (SSH)#22#" & wizssh & "#@" & optSubnet & "\" > \"" & binaryPath & "np.conf-wiz\" " with administrator privileges
	do shell script "echo \"Remote Login (TELNET,RSH,RLOGIN)#23,514,513#" & wiztelnet & "#@" & optSubnet & "\" >> \"" & binaryPath & "np.conf-wiz\" " with administrator privileges
	do shell script "echo \"System services#53,67,68,123,5353#allow#@" & optSubnet & "\" >> \"" & binaryPath & "np.conf-wiz\" " with administrator privileges
	do shell script "echo \"Web Server (HTTP)#80#" & wizweb & "#@" & optSubnet & "\" >> \"" & binaryPath & "np.conf-wiz\" " with administrator privileges
	do shell script "echo \"Windows Sharing (SMB)#139,445#" & wizsmb & "#@" & optSubnet & "\" >> \"" & binaryPath & "np.conf-wiz\" " with administrator privileges
	do shell script "echo \"Printer Sharing#515,631#" & wizprinter & "#@" & optSubnet & "\" >> \"" & binaryPath & "np.conf-wiz\" " with administrator privileges
	do shell script "echo \"Apple File Sharing (AFP)#548#" & wizafp & "#@" & optSubnet & "\" >> \"" & binaryPath & "np.conf-wiz\" " with administrator privileges
	do shell script "echo \"Internet File Sharing (FTP)#20-21#" & wizftp & "#@" & optSubnet & "\" >> \"" & binaryPath & "np.conf-wiz\" " with administrator privileges
	do shell script "echo \"Remote Apple Events#3031#" & wizevents & "#@" & optSubnet & "\" >> \"" & binaryPath & "np.conf-wiz\" " with administrator privileges
	do shell script "echo \"Remote Desktop and Management#3283#" & wizmanagement & "#@" & optSubnet & "\" >> \"" & binaryPath & "np.conf-wiz\" " with administrator privileges
	do shell script "echo \"iTunes Music Sharing#3689#" & wizitunes & "#@" & optSubnet & "\" >> \"" & binaryPath & "np.conf-wiz\" " with administrator privileges
	do shell script "echo \"iChat (bonjour, AV, ScreenSharing)#5060,5297,16384-16403#" & wizichat & "#@" & optSubnet & "\" >> \"" & binaryPath & "np.conf-wiz\" " with administrator privileges
	do shell script "echo \"VPN (L2TP)#500,1701,1723,4500,10000#" & wizvpn & "#@" & optSubnet & "\" >> \"" & binaryPath & "np.conf-wiz\" " with administrator privileges
	do shell script "echo \"Screen Sharing#5900#" & wizscreen & "#@" & optSubnet & "\" >> \"" & binaryPath & "np.conf-wiz\" " with administrator privileges
	do shell script "echo \"iPhoto Sharing#8770#" & wiziphoto & "#@" & optSubnet & "\" >> \"" & binaryPath & "np.conf-wiz\" " with administrator privileges
	do shell script "echo \"*All other services##" & wizall & "#@" & optSubnet & "\" >> \"" & binaryPath & "np.conf-wiz\" " with administrator privileges
	if wizAllow is equal to 2 then
		-- change 'true' and 'false' to 'allow only..' and 'deny' and copy it to default np.conf
		do shell script "cat \"" & binaryPath & "np.conf-wiz\" | sed 's/true/allow only../g' | sed 's/false/deny/g' > \"" & binaryPath & "np.conf\"" with administrator privileges
	else
		-- change 'true' and 'false' to 'allow' and 'deny' and copy it to default np.conf
		do shell script "cat \"" & binaryPath & "np.conf-wiz\" | sed 's/true/allow/g' | sed 's/false/deny/g' > \"" & binaryPath & "np.conf\"" with administrator privileges
	end if
	--
	updateNoob()
	-- set bandwidth limit
	if the current row of matrix "bwmatrix" of window "wizardbw" is equal to 1 then
		set the content of button "bw2" of window "bw" to true as boolean
		set the content of button "bwlan" of window "bw" to true as boolean
		set the content of text field "bw" of window "bw" to the content of text field "bw" of box "bw" of window "wizardbw"
		
	else
		set the content of button "bw2" of window "bw" to false as boolean
		set the content of button "bwlan" of window "bw" to false as boolean
	end if
	
	-- START THE FIREWALL
	if wizMode is equal to 1 then
		-- normal mode
		set the content of button "activate" of window "noobproof" to true as boolean
		set the enabled of button "flush" of window "noobproof" to false as boolean
		set the enabled of button "openbw" of window "noobproof" to false as boolean
		set the enabled of button "saveconf" of window "tools" to true as boolean
		set the enabled of button "import" of window "noobproof" to false as boolean
		set the enabled of button "export" of window "noobproof" to false as boolean
		set the enabled of button "stealth" of window "noobproof" to false as boolean
		noobStart()
		checkLock()
		updateMatrix()
		updateHosts()
		-- update rules window
		set the contents of text view "showrules" of scroll view "showrules" of window "showrules" to ""
		set the contents of text view "showrules" of scroll view "showrules" of window "showrules" to do shell script "/sbin/ipfw list" with administrator privileges
	else
		-- supernoobmode mode
		set the content of button "activate" of window "noobproof" to false as boolean
		set the enabled of button "openbw" of window "noobproof" to false as boolean
		set the content of button "stealth" of window "noobproof" to true as boolean
		stealthMode()
	end if
	-- INSTALL STARTUP SCRIPT
	if wizBoot is equal to 1 then
		installStartup()
		backupConf()
		if wizSuperNoob is equal to false as boolean then
			set the enabled of button "import" of window "noobproof" to true as boolean
			set the enabled of button "export" of window "noobproof" to true as boolean
			set the enabled of button "openbw" of window "noobproof" to true as boolean
		end if
		--displayDialogOK("Firewall configuration will be loaded at system boot.")
	else
		-- delete startup scripts and prefs
		uninstallNoob()
		if wizSuperNoob is equal to false as boolean then
			set the enabled of button "import" of window "noobproof" to true as boolean
			set the enabled of button "export" of window "noobproof" to true as boolean
			set the enabled of button "openbw" of window "noobproof" to true as boolean
		end if
	end if
	
	-- close last wizard window
	set the visible of progress indicator "spin" of window "wizard6" to false as boolean
	tell progress indicator "spin" of window "wizard6" to stop
	close panel (window "wizard6")
	set the enabled of button "closewizard" of window "wizard6" to true as boolean
	set the enabled of button "back6" of window "wizard6" to true as boolean
	set the enabled of button "abortwiz" of window "wizard6" to true as boolean
	displayDialogOK("Mac OS X firewall is now active with NoobProof settings. Please see the \"Help\" menu for more info.")
	saveOptionsPrefs()
end getWizardConf


-- *********************************************************************************************

-- get my ip address

on getNetworkConf()
	-- first device in order
	--set firstDev to do shell script "networksetup -listnetworkserviceorder |grep \"(1)\" |cut -d \" \" -f2" with administrator privileges
	-- get 
	--set firstIP to do shell script "networksetup -getinfo " & firstDev & " |grep -v IPv6 |grep \"IP address\" |cut -d \":\" -f2 |sed 's/ //g'" with administrator privileges
	--set firstMask to do shell script "networksetup -getinfo " & firstDev & " |grep -v IPv6 |grep \"Subnet mask\" |cut -d \":\" -f2 |sed 's/ //g'" with administrator privileges
	set firstIP to do shell script "ifconfig |grep \"inet \" |grep -v 127.0.0.1 | cut -d \" \" -f 2 |head -1" with administrator privileges
	set IPrange to do shell script "echo \"" & firstIP & " |cut -d\".\" -f1-3\"" with administrator privileges
	--debug
	displayDialogOK("IP: " & firstIP)
end getNetworkConf

on showLicense()
	do shell script "open -a TextEdit \"" & binaryPath & "COPYING.txt\"" with administrator privileges
end showLicense


-- *********************************
-- FILTERS (OUTBOUND)
-- *********************************

on updateFilters()
	-- echo $((`echo $string|sed 's/[^i]//g'|wc -m`-1))
	set filtersCount to do shell script "echo $((`cat \"" & binaryPath & "filters\" |sed 's/[^#]//g'|wc -m`-1))" with administrator privileges
	--
	set filtersTableView to table view "filters" of scroll view "filters" of window "filters"
	
	set hcount to 1
	set the content of filtersTableView to {}
	set theDataSource to data source of filtersTableView
	repeat with hcount from 1 to filtersCount
		--displayDialogOK("conto " & hcount & " su " & hostnum)
		
		set hostString to do shell script "cat \"" & binaryPath & "filters\" | cut -d \"#\" -f" & hcount
		-- debug
		--displayDialogOK("UPDATEHOSTSreading conf: servname: " & srvname & " - hosts in list: " & hostnum & " - this host: " & hostString)
		set theTask to make new data row at end of data rows of theDataSource
		set contents of data cell "hostlist" of theTask to hostString
		set hcount to hcount + 1
	end repeat
	--debug
	--displayDialogOK("filters count: " & filtersCount)
	
end updateFilters


-- ADD
on addFilters()
	try
		-- get ip
		set theFilter to the contents of text field "addfilters" of window "addfilters"
		-- update conf file
		set filterList to do shell script "cat \"" & binaryPath & "filters\"" with administrator privileges
		set newFilterList to (filterList & theFilter & "#")
		-- deletes old conf file
		do shell script "rm -f \"" & binaryPath & "filters\"" with administrator privileges
		-- create new conf file
		do shell script "echo \"" & newFilterList & "\" > \"" & binaryPath & "filters\"" with administrator privileges
	on error errorText
		displayDialogOK("error adding new filter: " & errorText)
	end try
end addFilters


-- DELETE
on deleteFilters()
	try
		set filtersTableView to table view "filters" of scroll view "filters" of window "filters"
		set selectedRow to selected row of filtersTableView
		set theFilter to the contents of data cell "hostlist" of selected data row of filtersTableView
		--debug
		--displayDialogOK("selected filter: " & theFilter)
		set newFilterList to do shell script "cat \"" & binaryPath & "filters\" |sed s/" & theFilter & "#" & "//g" with administrator privileges
		-- deletes old conf file
		do shell script "rm -f \"" & binaryPath & "filters\"" with administrator privileges
		-- create new conf file
		do shell script "echo \"" & newFilterList & "\" > \"" & binaryPath & "filters\"" with administrator privileges
	end try
end deleteFilters

-- CLEAN
on cleanFilters()
	try
		-- deletes old conf file
		do shell script "rm -f \"" & binaryPath & "filters\"" with administrator privileges
		-- create new empty conf file
		do shell script "touch \"" & binaryPath & "filters\"" with administrator privileges
	end try
end cleanFilters



-- *********************************
-- FILTERS (INBOUND)
-- *********************************

on updateinFilters()
	-- echo $((`echo $string|sed 's/[^i]//g'|wc -m`-1))
	set filtersCount to do shell script "echo $((`cat \"" & binaryPath & "infilters\" |sed 's/[^#]//g'|wc -m`-1))" with administrator privileges
	--
	set filtersTableView to table view "infilters" of scroll view "infilters" of window "filters"
	
	set hcount to 1
	set the content of filtersTableView to {}
	set theDataSource to data source of filtersTableView
	repeat with hcount from 1 to filtersCount
		--displayDialogOK("conto " & hcount & " su " & hostnum)
		
		set hostString to do shell script "cat \"" & binaryPath & "infilters\" | cut -d \"#\" -f" & hcount
		-- debug
		--displayDialogOK("UPDATEHOSTSreading conf: servname: " & srvname & " - hosts in list: " & hostnum & " - this host: " & hostString)
		set theTask to make new data row at end of data rows of theDataSource
		set contents of data cell "hostlist" of theTask to hostString
		set hcount to hcount + 1
	end repeat
	--debug
	--displayDialogOK("filters count: " & filtersCount)
	
end updateinFilters


-- ADD
on addinFilters()
	try
		-- get ip
		set theFilter to the contents of text field "addinfilters" of window "addinfilters"
		-- update conf file
		set filterList to do shell script "cat \"" & binaryPath & "infilters\"" with administrator privileges
		set newFilterList to (filterList & theFilter & "#")
		-- deletes old conf file
		do shell script "rm -f \"" & binaryPath & "infilters\"" with administrator privileges
		-- create new conf file
		do shell script "echo \"" & newFilterList & "\" > \"" & binaryPath & "infilters\"" with administrator privileges
	on error errorText
		displayDialogOK("error adding new infilter: " & errorText)
	end try
end addinFilters


-- DELETE
on deleteinFilters()
	try
		set filtersTableView to table view "infilters" of scroll view "infilters" of window "filters"
		set selectedRow to selected row of filtersTableView
		set theFilter to the contents of data cell "hostlist" of selected data row of filtersTableView
		--debug
		--displayDialogOK("selected filter: " & theFilter)
		set newFilterList to do shell script "cat \"" & binaryPath & "infilters\" |sed s/" & theFilter & "#" & "//g" with administrator privileges
		-- deletes old conf file
		do shell script "rm -f \"" & binaryPath & "infilters\"" with administrator privileges
		-- create new conf file
		do shell script "echo \"" & newFilterList & "\" > \"" & binaryPath & "infilters\"" with administrator privileges
	end try
end deleteinFilters

-- CLEAN
on cleaninFilters()
	try
		-- deletes old conf file
		do shell script "rm -f \"" & binaryPath & "infilters\"" with administrator privileges
		-- create new empty conf file
		do shell script "touch \"" & binaryPath & "infilters\"" with administrator privileges
	end try
end cleaninFilters


























